#ifndef		__CXCONNECTION_H__
#define		__CXCONNECTION_H__
#include	<qobject.h>
#include	<qdict.h>
#include	<qlist.h>
#include	<time.h>
#include	<dcopclient.h>
#include	<qstring.h>
#include	<CxClient.h>

#define		MSG_INIT	0	/** Initial message flags: Nothing... **/
#define		MSG_HEADER	1	/** Message header is cached and complete. **/
#define		MSG_BODY	2	/** Message body is cached and complete. **/
#define		MSG_UNREAD	4	/** This message is unread. **/

typedef struct	_cppmesginfo {

	long unsigned
	int		MessageId;
	QCString	Author,
			Recipient,
			Subject,
			Room,
			Path,
			Node,
			Date,
			MessageBody;
	unsigned long	unix_timestamp;

	unsigned int	flags;
}		QMesgInfo;

class	CxCacheMgr;

/**
 ** Citadel/UX Server connnection object.
 **/
class		CxConnection: public QObject {
Q_OBJECT

public:

		CxConnection( const QString& = QString::null, const QString& = QString::null, const QString& = QString::null );
		~CxConnection();

inline	bool		isOnline() { return(g_isOnline); };

	QList<QString>	getOnlineUsers();
	QList<QString>	getAllUsers();

CXLIST*			floorCache();

signals:
	void		error( const QString& );
	void		comingOnline();
	void		amOnline();
	void		updatingStart();
	void		updatingFinish();
	void		goingOffline();
	void		amOffline();
	void		handleExpressMsg( const QString&, const QString& );
	void		expMesgFailed();
	void		hasMail();
	void		badPassword( const QString &, const QString & );

public slots:
	void		connect();
	void		disconnect();
	void		sync();
inline	void		setHostName( const QString& s ) { g_serverName = new QString( s ); g_isConfigured = true; };
inline	void		setUserName( const QString& s ) { g_userName = new QString( s );  g_isConfigured = true;};
inline	void		setPassword( const QString& s ) { g_password = new QString( s );  g_isConfigured = true;};
inline	QString		getHostName() { return( g_serverName->copy() ); };
inline	QString		getUserName() { return( g_userName->copy() ); };
	void		sendExpressMsg( const QString&, const QString& );
	void		checkExpressMsg();
	void		checkMail();
	QCStringList	fetchNotes();
	QCStringList	fetchMessageList( const QString &, bool = true );
	QCStringList	fetchFolderList();
	int		deliverMessage( QCStringList * );
	QMesgInfo	*fetchMesgInfo( const QString &, long unsigned int, bool );
	QCStringList	fetchMessage( const QCString &, long unsigned int );
	QCStringList	cacheStats();

private slots:
	void		recvExpressMsg();
	void		syncSlave();
	void		syncFloors();
	void		syncRooms();
	void		syncUsers();

private:
	QString		resolveRoomName( const QString& );

protected:
	QString		*g_userName,
			*g_password,
			*g_serverName;
	bool		g_isOnline,
			g_isConfigured,
			g_hasMail;
	USERINFO	*i_userInfo;
	CXLIST		l_floorIndex,
			l_roomsIndex,
			l_usersIndex,
			l_allUsersIndex,
			l_messageIndex,
			l_messageInfoIndex,
			l_messageUnreadIndex;
	int		g_hasBeenUpdated;
	int		g_cxHndl;

	char		*g_Ser[10];

	QString		g_currentRoom;

	CxCacheMgr	*g_CacheMgr;
};

#endif
