/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: cxdaemon.o
 ** Date: 2001-03-08
 ** Last Revision: 2001-03-08
 ** Description: CxDaemon interface.
 ** CVS: $Id: cxdaemon.cpp,v 1.14 2001/08/28 02:54:11 brian Exp $
 **/
#include	<kapp.h>
#include	<kdebug.h>
#include	<knotifyclient.h>
#include	<CxClient.h>
#include	"cxdaemon.h"
#include	"wndabout.h"
#include	"wndbuddylist.h"
#include	"wndprefs.h"
#include	"cxconnection.h"
#include	"cxdaemontray.h"

/**
 ** CxDaemonMgr::CxDaemonMgr(): Constructor.
 **/
		CxDaemonMgr::CxDaemonMgr( const QString& fun, QWidget *parent, const char *name )
		:QObject( parent, name ),DCOPObject( "CxMessenger" ) {

	if(fun.isNull()) ;

	docker = new CxDaemonTray( this, "CxDaemonTray" );
	docker->show();
}

/**
 ** CxDaemonMgr::~CxDaemonMgr(): DESTRUCTOR.
 **/
		CxDaemonMgr::~CxDaemonMgr() {

	kdDebug() << "CxDaemonMgr::~CxDaemonMgr()" << endl;
	delete docker;

	/**
	 ** When we close, we should send a memo to the running Infusion
	 ** clients that they should close, too, since we're the Boss.
	kapp->dcopClient()->send("infusion","CxWndMain","close()","");
	 **/
}

/**
 ** CxDaemonMgr::sync(): DCOP: Synchronize our lists.
 **/
ASYNC		CxDaemonMgr::sync() {
	emit docker->syncLists();
}

/**
 ** CxDaemonMgr::buddyList(): DCOP: Raise a BuddyList window.
 **/
void		CxDaemonMgr::buddyList() {

	emit docker->raiseBuddyDlg();
}

/**
 ** CxDaemonMgr::goOnline(): DCOP: Go online.
 **/
void		CxDaemonMgr::goOnline() {

	emit docker->slotGoOnline();
}

/**
 ** CxDaemonMgr::goOffline(): DCOP: 
 **/
void 		CxDaemonMgr::goOffline() {

	emit docker->slotGoOffline();
}

/**
 ** CxDaemonMgr::accountName(): DCOP: 
 **/
QString 	CxDaemonMgr::accountName() {

	return(docker->getUserName());
}

/**
 ** CxDaemonMgr::fetchNotes(): DCOP: 
 **/
QCStringList 	CxDaemonMgr::fetchNotes() {

	return(docker->fetchNotes());
}

/**
 ** CxDaemonMgr::fetchMessageList(): DCOP: 
 **/
QCStringList 	CxDaemonMgr::fetchMessageList( int cache_results, QString room ) {

	return(docker->fetchMessageList( QString(room), cache_results ));
}

/**
 ** CxDaemonMgr::fetchFolderList(): DCOP: 
 **/
QCStringList 	CxDaemonMgr::fetchFolderList() {

	return(docker->fetchFolderList());
}

/**
 ** CxDaemonMgr::deliverMessage(): DCOP: 
 **/
int 		CxDaemonMgr::deliverMessage( QCStringList msg ) {

	return(docker->deliverMessage( &msg ));
}

/**
 ** CxDaemonMgr::cacheStats(): DCOP: 
 **/
QCStringList	CxDaemonMgr::cacheStats() {

	kdDebug() << "CxDaemonMgr::cacheStats(): Called" << endl;
	return( docker->cacheStats() );
}

/**
 ** CxDaemonMgr::fetchMessage(): DCOP: 
 **/
QCStringList	CxDaemonMgr::fetchMessage( QCString room, unsigned int msg_id ) {

	return(docker->fetchMessage( room, msg_id ));
}

/**
 ** CxDaemonMgr::showAlarms(): 
 **/
//void		CxDaemonMgr::showAlarms(QList<KOEvent> &alarmEvents) {
//
//	if(alarmEvents.isEmpty());
//}

/**
 ** CxDaemonMgr::reloadCal(): 
 **/
void		CxDaemonMgr::reloadCal() {
}

/**
 ** CxDaemonMgr::suspend():
 **/
void		CxDaemonMgr::suspend(int duration) {

	if(duration);
}

/**
 ** CxDaemonMgr::showDialog(): 
 **/
void		CxDaemonMgr::showDialog() {
}

/*******************************************************************
 ** CxDaemon::CxDaemon(): CONSTRUCTOR.
 **/
		CxDaemon::CxDaemon()
		:KUniqueApplication()
		,trayMgr( NULL ) {

	g_dcopClient = dcopClient();
}

/**
 ** CxDaemon::~CxDaemon(): DESTRUCTOR.
 **/
		CxDaemon::~CxDaemon() {

	delete trayMgr;
}

/**
 ** CxDaemon::newInstance():
 **/
int		CxDaemon::newInstance() {

	if(trayMgr) return(0);
//	KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
 
	trayMgr = new CxDaemonMgr(QString::null, 0, "CxDaemonMgr");
 
	return(0);
}
