#ifndef		__CXDAEMON_H__
#define		__CXDAEMON_H__
#include	<kuniqueapp.h>
#include	<kpixmap.h>
#include	<ksystemtray.h>
#include	"cxconnection.h"
#include	"wndabout.h"
#include	"wndchat.h"
#include	"wndbuddylist.h"
#include	"cxmessenger.h"
#include	"cxdaemontray.h"

/**
 ** class CxDaemonMgr: Tray manager.
 **/
class		CxDaemonMgr
		:public QObject, virtual public CxMessenger {
Q_OBJECT

public:
		CxDaemonMgr( const QString&, QWidget *, const char *);
		~CxDaemonMgr();

	bool		oldProcess(const QCString &, 
				const QByteArray &, QCString &, 
				QByteArray &);
	ASYNC 		sync();
	void 		buddyList();
	void 		goOnline();
	void 		goOffline();
	QString 	accountName();
	QCStringList 	fetchNotes();
	QCStringList 	fetchMessageList( int,QString );
	QCStringList 	fetchFolderList();
	int 		deliverMessage( QCStringList );
	QCStringList 	fetchMessage( QCString, unsigned int );
	QCStringList	cacheStats();

public slots:
	void		reloadCal();
	void		suspend(int duration);
	void		showDialog();
 
private:
	CxDaemonTray	*docker;
	QTimer		*mSuspendTimer;
};

/**************************************************
 ** class CxDaemon: Handler for the SysTray object.
 **/
class 		CxDaemon 
		:public KUniqueApplication {
Q_OBJECT

public:
		CxDaemon();
virtual		~CxDaemon();

private slots:
	int		newInstance();

protected:
	DCOPClient	*g_dcopClient;
	CxDaemonMgr	*trayMgr;
};

#endif
