#ifndef		__CXDAEMONTRAY_H__
#define		__CXDAEMONTRAY_H__
#include	<kuniqueapp.h>
#include	<kpixmap.h>
#include	<ksystemtray.h>
#include	"cxconnection.h"
#include	"wndabout.h"
#include	"wndchat.h"
#include	"wndbuddylist.h"

/**************************************
 ** class CxDaemonTray: SysTray object.
 **/
class 		CxDaemonTray
		:public KSystemTray {
Q_OBJECT

enum CurrentState {
	Offline,
	Online,
	Error,
	Working,
	NewMail
};

public:
		CxDaemonTray(QObject *parent = NULL, const char *name = 0L);
virtual		~CxDaemonTray();

	bool		alarmsOn();
	void		addToolTip(const QString&);
	CXLIST		*getFloorCache();

signals:
	void		checkMail();
	void		goOffline();
	void		goOnline();

public slots:
	void		verifyPassword( const QString&, const QString& );
	void		toggleAlarmsEnabled();
	void		raiseAboutDlg();
	void		raiseBuddyDlg();
	void		reapBuddyDlg();
	void		raisePrefsDlg();
	void		setIcon( CurrentState );
	void		setIconOnline();
	void		setIconWorking();
	void		setIconNormal();
	void		setIconOffline();
	void		setIconNewMail();
	void		syncLists();
	void		configurationChanged();
	QString		getUserName();
	void		slotGoOnline();
	void		slotGoOffline();
	QCStringList	fetchNotes();
	QCStringList	fetchMessageList( const QString &, bool );
	QCStringList	fetchFolderList();
	int		deliverMessage( QCStringList * );
	QCStringList	fetchMessage( const QCString &, long unsigned int );
	void		slotExpressMsg( const QString&, const QString & );
	QCStringList	cacheStats();

private slots:
	void		launchInfusion();
	void		errorMsg( const QString & );
	void		initConnection();
	void		initIcons();
	void		autoSyncLists();
	void		openChatWin( const QString& );
	void		closeChatWin( const QString& );
	void		doCheckMail();

protected:
	void		mousePressEvent(QMouseEvent *);
	void		closeEvent(QCloseEvent *e);

	QTimer		*checkMailTimer;

	CxWndChat	&chatWin(const QString&); 

	CxConnection	*g_cxConxion;

	KPixmap		pix1;
	KPixmap 	pix2;
	KPixmap 	pix3;
	KPixmap 	pixNewMail;
	int		itemId, refreshId;
	bool		g_isWorking;

	CxWndBuddylist	*w_buddyList;
	QDict<CxWndChat>
			w_chatWindows;

	bool		g_newMailWaiting,
			g_firstRun,
			g_savePassword;
};

#endif
