/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/wndbuddylist.o
 ** Date: 2000-11-12
 ** Last Revision: 2000-11-12
 ** Description: Buddy list.  (Mostly, select someone to chat with)
 ** CVS: $Id: wndbuddylist.cpp,v 1.2 2001/07/17 21:05:41 brian Exp $
 **/
#include	"wndbuddylist.h"
#include	<stdlib.h>
#include	<iostream.h>
#include	<kmainwindow.h>
#include	<kmessagebox.h>
#include	<ktabctl.h>
#include	<klocale.h>
#include	<kcontainer.h>
#include	<kdialogbase.h>
#include	<qlayout.h>
#include	<qlist.h>
#include	<qvbox.h>
#include	<qlabel.h>
#include	<stdio.h>
#include	<CxClient.h>

/**
 ** CxWndBuddylist::Constructor()
 **/
		CxWndBuddylist::CxWndBuddylist(): 
			KMainWindow(0, "wndBuddies")
			{

	setCaption(QString("Buddy List"));

	QVBox *page = new QVBox(this);
	page->setMargin(4);
	page->setSpacing(4);
	setCentralWidget(page);

	uList = new CxObjUserlist(page, 0, QString::null);

	QPushButton *pb = new QPushButton(QString("Chat"), page);
	connect(pb, SIGNAL(clicked()), SLOT(slotChat()));

	resize(300,200);
}

/**
 ** CxWndBuddylist::closeEvent(): What do we do when we exit?
 **/
void 		CxWndBuddylist::closeEvent(QCloseEvent *) {

	emit closing();
	delete(this);
}

/**
 ** CxWndBuddylist::slotOk(): I'm outta here!
 **/
void		CxWndBuddylist::slotChat() {

	if(uList->selectedItem()) {
		emit openChatWindow(uList->selectedItem()->text(1));
	}
}

/**
 ** CxWndBuddylist::slotExit(): I'm outta here!
 **/
void		CxWndBuddylist::slotExit() {

	close();
}

/**
 ** CxWndBuddylist::slotPopulateOnline(): Populate the online user list.
 **/
void		CxWndBuddylist::slotPopulateOnline( QList<QString> list ) {

	emit uList->slotPopulateOnline( list );
}

/**
 ** CxWndBuddylist::slotPopulateUsers(): Populate the online user list.
 **/
void		CxWndBuddylist::slotPopulateUsers( QList<QString> list ) {

	emit uList->slotPopulateUsers( list );
}
