/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: main.o
 ** Date: 2000-10-15
 ** Last Revision: 2001-01-08
 ** Description: KDE2 module interface.
 ** CVS: $Id: main.cpp,v 1.10 2001/08/28 01:21:35 brian Exp $
 **/
extern "C" {
     #include <stdio.h>
     #include <stdlib.h>
}
#include	<iostream.h>
#include	<kapp.h>
#include	<kconfig.h>
#include	<dcopclient.h>
#include	<kaboutdata.h>
#include	<kcmdlineargs.h>
#include	<klocale.h>
#include	<CxClient.h>
#include	<qstring.h>
#include	"wndmain.h"
#include	"wndlogin.h"
#include	"rfc2426.h"
#include	"sysmgmt.h"
#include	"autoconf.h"

KApplication	*g_InfusionApp;
CxWndMain	*wndMain;

/**
 ** Initialize module
 **/ 
int		main(int argc, char *args[]) {
char		buf[255];

	if(!getenv("DISPLAY")) {
		cout << "* * *  Unable to start Infusion!  * * *" << endl;
		cout << "Please verify that you are running the X Windowing System, and" << endl;
		cout << "ensure that your DISPLAY environment variable is properly set." << endl;
		exit(0);
	}

	KAboutData      CxAbout(
                        I18N_NOOP("Infusion"),
                        I18N_NOOP("Infusion"),
                        "1.0",
                        I18N_NOOP("Infusion Communications System"),
                        KAboutData::License_BSD,
                        "Copyright (c) 2000, SCCG/Flaming Sword Productions",
                        "http://www.shadowcom.net/Software/infusion/",
                        I18N_NOOP("The best communications client in the world!"),
                        "brian@shadowcom.net"
                );

        static KCmdLineOptions options[] = {
                {0, 0, 0}
        };
 
        KCmdLineArgs::init(argc,args,&CxAbout);

        KCmdLineArgs::addCmdLineOptions(options);

	/**
	 ** Instruct the libCxClient subsystem as to which version of Infusion
	 ** this is.
	 **/
	sprintf(buf, "Infusion %s", VERSION);
	CxClRegClient(buf);

	g_InfusionApp = new KApplication;

	wndMain = new CxWndMain();
	g_InfusionApp->setMainWidget(wndMain);
	wndMain->show();

	CxWndLogin *dlg = new CxWndLogin(g_InfusionApp, QString("Login"));
	if(!dlg->isCached()) dlg->show();

	g_InfusionApp->exec();

	cout << "Thank-you for using Infusion!" << endl;
	cout << "(This program is a work in progress.  I hope it's getting better! :)" << endl;
}
