/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objaddrbookview.o
 ** Date: 2001-02-26
 ** Last Revision: 2001-08-28
 ** Description: Implementation for Address Book View.
 ** CVS: $Id: objaddrbookview.cpp,v 1.8 2001/09/08 02:12:06 brian Exp $
 **/
#include	<qwidget.h>
#include	<qpalette.h>
#include	<qhbox.h>
#include	<qvbuttongroup.h>
#include	<qpushbutton.h>
#include	<qvbox.h>
#include	<qurl.h>
#include	<qcanvas.h>
#include	<klistview.h>
#include	<kdebug.h>
#include	<kparts/part.h>
#include	<kiconloader.h>
#include	<qhbox.h>
#include	<qpopupmenu.h>
#include	<CxClient.h>
#include	"objgenericview.h"
#include	"objaddrbookview.h"
#include	"rfc2426.h"

CXOBJDEF        CXCONTACTS = {
	"cxobjaddrbookview",
	"Contacts",
	"ktalkd"
};

/**
 ** CxObjContactsList::CxObjContactsList(): CONSTRUCTOR.  
 **/
		CxObjContactsList::CxObjContactsList( QWidget *parent )
		:QHBox( parent ) {

	g_ColumnCount = 0;

	p_stdPalette = palette();
	p_altPalette = palette();
	p_hiPalette = palette();
	QColor bgc_dark = p_stdPalette.color(QPalette::Active, QColorGroup::Background).dark(120);
	QColor bgc_light = p_stdPalette.color(QPalette::Active, QColorGroup::Background).dark(20);
	QColor bgc = Qt::white;
	QColor fgc_alt = Qt::white;
	QColor fgc = Qt::black;
	p_stdPalette.setColor(QColorGroup::Background, bgc);
	p_stdPalette.setColor(QColorGroup::Base, bgc);
	p_stdPalette.setColor(QColorGroup::Foreground, fgc);
	p_stdPalette.setColor(QColorGroup::Text, fgc);
	p_altPalette.setColor(QColorGroup::Background, bgc_dark);
	p_altPalette.setColor(QColorGroup::Base, bgc_dark);
	p_altPalette.setColor(QColorGroup::Foreground, fgc_alt);
	p_altPalette.setColor(QColorGroup::Text, fgc_alt);
	p_hiPalette.setColor(QColorGroup::Background, bgc_dark);
	p_hiPalette.setColor(QColorGroup::Base, bgc_light);
	p_hiPalette.setColor(QColorGroup::Foreground, fgc_alt);
	p_hiPalette.setColor(QColorGroup::Text, fgc_alt);

	i_scrollView = new QScrollView( this );
	i_scrollView->setVScrollBarMode( QScrollView::AlwaysOff );
	i_scrollView->setHScrollBarMode( QScrollView::Auto );
	i_scrollView->setPalette( p_stdPalette );

	i_containerBox = new QWidget( i_scrollView );
	i_scrollView->addChild( i_containerBox );
	i_containerBox->setBackgroundColor( Qt::white );
	i_containerBox->resize( 1024, 768 );
	i_containerBox->show();

	i_contactsContainer = new QHBox( i_containerBox );
	i_contactsContainer->resize( width(), height() );
	i_contactsContainer->setBackgroundColor( Qt::white );
	i_contactsContainer->setSpacing( 3 );
	i_contactsContainer->setMargin( 1 );

	clear();
}

/**
 ** CxObjContactsList::~CxObjContactsList(): DESTRUCTOR.  
 **/
		CxObjContactsList::~CxObjContactsList() {
}

/**
 ** CxObjContactsList::clear(): Clear our lists, and our ui.
 **/
void		CxObjContactsList::clear() {
}

/**
 ** CxObjContactsList::insert(): We didn't specify a complete RFC2426 object,
 ** so build one for us.
 **/
void		CxObjContactsList::insert( const QString& contactName ) {

	Rfc2426 *contact = new Rfc2426( contactName );
	insertContact( contact );
}

/**
 ** CxObjContactsList::insert(): Insert a complete RFC2426 object into
 ** our contacts list. 
 **/
void		CxObjContactsList::insert( const Rfc2426& contact ) {

//	insertContact( &contact );
}

/**
 ** CxObjContactsList::remove(): Remove a contact from the contact list.
 **/
void		CxObjContactsList::remove( const QString& contactName ) {
}

/**
 ** CxObjContactsList::restrictView(): This is pretty much the event handler
 ** for the index buttons.
 **/
void		CxObjContactsList::restrictView( const QString& expression ) {
}

/**
 ** CxObjContactsList::insertContact(): This handles the gruntwork for inserting
 ** a new contact into the fray...
 **/
void		CxObjContactsList::insertContact( Rfc2426 *contact ) {

	kdDebug() << "CxObjContactsList::insertContact(): need to insert..." << endl;
	/* for( int i = 0; i < 5; i++ ) {
		QVBox *sampleContact = new QVBox( contactColumn );
		sampleContact->setFixedWidth( 100 );
		sampleContact->setFrameStyle( QFrame::Box );
		sampleContact->setFrameShadow( QFrame::Plain );
		sampleContact->setBackgroundColor( Qt::white );
		sampleContact->setMargin( 2 );

		QLabel *lbl = new QLabel( QString("User, Joe"), sampleContact );
		lbl->setFont( QFont( "helvetica", 12, QFont::Bold ) );
		lbl->setPalette( (!i?hipalette:altpalette) );
		lbl = new QLabel( QString("Megasloth Corporation"), sampleContact );
		lbl->setFont( QFont( "helvetica", 10 ) );
		lbl = new QLabel( QString("joeuser@megasloth.com"), sampleContact );
		lbl->setFont( QFont( "helvetica", 10 ) );

		sampleContact->setFixedHeight( 50 );
	} */
}

/**
 ** CxObjContactsList::createColumn(): Insert a new column for contacts 
 ** into our view.
 **/
void		CxObjContactsList::createColumn() {

	/*QVBox *contactColumn = new QVBox( contactsContainer );
	contactColumn->setFixedWidth( 105 );
	contactColumn->setBackgroundColor( Qt::white );
	contactColumn->setSpacing( 3 );
	contactColumn->setMargin( 1 );

	QWidget *rowspacer = new QWidget( contactColumn );

	QFrame *sep = new QFrame( contactsContainer );
	sep->setFixedWidth( 3 );
	sep->setFrameStyle( QFrame::VLine );
	sep->setFrameShadow( QFrame::Plain );

	QWidget *colspacer = new QWidget( contactsContainer ); */
}

/**
 ** CxObjAddrBookView::CxObjAddrBookView(): Constructor.
 **/
		CxObjAddrBookView::CxObjAddrBookView(QWidget *parent):
				CxObjGenericView( parent ) {

	mainContainer = new QHBox( this );

	QVBox *buttonGrp = new QVBox( mainContainer );
	buttonGrp->setFixedWidth( 55 );

	QPushButton *btn;
	btn = new QPushButton( QString(" * "), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("0-9"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("a-b"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("c-d"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("e-f"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("g-h"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("i-j"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("k-l"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("m-n"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("o-p"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("q-r"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("s-t"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("w-x"), buttonGrp );
	btn->setFixedWidth( 33 );
	btn = new QPushButton( QString("y-z"), buttonGrp );
	btn->setFixedWidth( 33 );

	contactList = new CxObjContactsList( mainContainer );
	contactList->show();

	resize( size() );
}

/**
 ** CxObjAddrBookView::refresh(): Refresh the message list.
 **/
void            CxObjAddrBookView::refresh() {

	contactList->clear();
	for( int i = 0; i < 5; i++ ) {
		contactList->insert( QString("TestUser %1").arg( i ) );
	}
}

/**
 ** CxObjAddrBookView::clear(): Clear the AddrBookView.
 **/
void            CxObjAddrBookView::clear() {

	contactList->clear();
}

/**
 ** CxObjAddrBookView::resizeEvent(): Handle any resize events we receive.
 **/
void		CxObjAddrBookView::resizeEvent( QResizeEvent *ev ) {
int		width;

//	width = (ev->size().width() >= contactsContainer->width()? contactsContainer->width() : ev->size().width());

	width = scrollView->width() - 4;
//	contactList->resize( width, ev->size().height() );
}
