/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objaddrbookview.h
 ** Date: 2001-02-26
 ** Last Revision: 2001-02-26
 ** Description: Interface for Address Book View.
 ** CVS: $Id: objaddrbookview.h,v 1.8 2001/09/08 02:12:06 brian Exp $
 **/
#ifndef		__OBJADDRBOOKVIEW_H__
#define		__OBJADDRBOOKVIEW_H__
#include	<qwidget.h>
#include	<qcanvas.h>
#include	<klistview.h>
#include	<kiconloader.h>
#include	<kparts/part.h>
#include	<qhbox.h>
#include	<qpopupmenu.h>
#include	<CxClient.h>
#include	"objgenericview.h"
#include	"rfc2426.h"

/**
 ** class CxObjContactsList: This is the contact list widget, which
 ** will be embedded by the main AddrBookView.  It will be a kludge
 ** for now (a QIconList, in fact), but should eventually closely
 ** resemble Outlook's contact list.
 **/
class		CxObjContactsList
		:public QHBox {
Q_OBJECT

public:
		CxObjContactsList( QWidget * );
		~CxObjContactsList();

	void			clear();
	void			insert( const QString& );
	void			insert( const Rfc2426& );
	void			remove( const QString& );

	void			restrictView( const QString& );

private:
	void			insertContact( Rfc2426* );
	void			createColumn();

protected:
	QDict<Rfc2426>		g_ContactInfo;
	QDict<QVBox>		g_ContactItem;
	QList<QVBox>		g_Columns;
	int			g_ColumnCount;

	QScrollView		*i_scrollView;
	QWidget			*i_containerBox;
	QHBox			*i_contactsContainer;

	QPalette		p_stdPalette;
	QPalette		p_altPalette;
	QPalette		p_hiPalette;
};

/**
 ** A AddrBookView is a subset of the GenericView object.  It also 
 ** inherits properties from a QCanvas.
 **/
class		CxObjAddrBookView: public CxObjGenericView {
friend		CxObjGenericView;
friend		KParts::ReadWritePart;
Q_OBJECT

public:
			CxObjAddrBookView(QWidget *);

inline	QPixmap		CxSmallIcon() { return(SmallIcon(QString("kab"))); };
inline	QPixmap		CxDesktopIcon() { return(DesktopIcon(QString("kab"),32)); };
inline	QPopupMenu*	CxObjectMenu() { return(NULL); };
inline 	QString		CxObjectName() { return(QString("Contacts")); };
inline 	KToolBar*	CxToolbar() {  return(i_toolBar); };

public slots:
	void		refresh();
	void		clear();

private slots:
	void		resizeEvent( QResizeEvent * );

private:
	CXLIST		_MesgIndex, _MesgInfo;
	QString		currentRoom;
	KListView	*myList;
	QPopupMenu	*m_ObjectMenu;
	KToolBar	*i_toolBar;

	QHBox		*mainContainer;
	QScrollView	*scrollView;
	QWidget		*containerBox;
	QHBox		*contactsContainer;

	CxObjContactsList
			*contactList;
/*
	QDict< CxObjAddrBookViewItem * >
			g_ContactList;
 */
};

#endif
