/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objfolderview.h
 ** Date: 2001-02-15
 ** Last Revision: 2001-02-15
 ** Description: Interface for folder view.
 ** CVS: $Id: objfolderview.h,v 1.8 2001/09/08 02:10:54 brian Exp $
 **/
#ifndef		__OBJFOLDERVIEW_H__
#define		__OBJFOLDERVIEW_H__
#include	<qwidget.h>
#include	<klistview.h>
#include	<kiconloader.h>
#include	<qsplitter.h>
#include	<CxClient.h>
#include	"objgenericview.h"
#include	"objmesgpane.h"

#if(KDE_VERSION >= 220)
#define		LISTVIEWITEM		KListViewItem
#else
#define		LISTVIEWITEM		QListViewItem
#endif

class		CxObjFolderView: public CxObjGenericView {
friend		CxObjGenericView;
Q_OBJECT

public:
			CxObjFolderView(QWidget *, const QString& = 0L );
inline	QPixmap		CxSmallIcon() { return(SmallIcon(QString("folder"))); };
inline	QPixmap		CxDesktopIcon() { return(DesktopIcon(QString("folder"),32)); };
inline	QPopupMenu*	CxObjectMenu() { return(NULL); };
inline	QString		CxObjectName() { return(QString("Folder")); };
inline	KToolBar	*CxToolbar() { return(NULL); };

inline	bool		isPaneVisible() { return( g_paneIsVisible ); };
inline	bool		isHdrVisible() { return( myMesgPane->isHdrVisible() ); };

	void		setSizes( QValueList<int> );
	QValueList<int>	sizes();

signals:
	void		clicked(LISTVIEWITEM *);

public slots:
	void		refresh();
	void		slotLoadMessage(const QString &, const QString &);
	void		clear();
	void		slotTogglePane();
	void		slotToggleHdr();
	void		gotoRoom( const QString &);

private slots:
	void		slotSelected(QListViewItem *);
	void		slotOpenMesg(QListViewItem *);
	void		slotShowProperties();
	void            rmbClicked( KListView *, QListViewItem *, const QPoint& );

private:
	CXLIST		_MesgIndex, _MesgInfo, _Unread;
	QString		currentRoom;
	KListView	*myList;
	CxObjMesgPane	*myMesgPane;
	QSplitter	*_splitter;

	bool		g_paneIsVisible;

	QPopupMenu	*m_contextMenu;
	int		m_replyId,
			m_replyAllId,
			m_forwardId,
			m_propsId;

	QString		lockedInRoom;
};

#endif
