/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objgenericview.h
 ** Date: 2001-02-19
 ** Last Revision: 2001-02-19
 ** Description: This is a generic interface to a View (Pane) object.
 ** CVS: $Id: objgenericview.h,v 1.5 2001/09/08 02:09:49 brian Exp $
 **/
#ifndef		__OBJGENERICVIEW_H__
#define		__OBJGENERICVIEW_H__
#include	<qwidget.h>
#include	<ktoolbar.h>
#include	<kparts/part.h>
#include	<qpopupmenu.h>
#include	<qhbox.h>
#include	<CxClient.h>
#include	"objmesgpane.h"

/**
 ** Object Definition Descriptor: We will use an CXOBJDEF
 ** structure to define all of our user interface modules.
 **/
typedef struct	_objdef {

	char 	_objname[255];
	char 	_uiname[255];
	char	_icon[255];

}		CXOBJDEF;

/**
 ** With this class, I am experimenting with some standardization
 ** abstractions.  I hope to generalize a View class which can be
 ** overridden with neat niftiness, and provide users with the
 ** ability to extend Infusion.  I am using this rudimentary object
 ** to hash out my ideas.  It will dramatically change once I figure
 ** out how I'm gonna do this... -b
 **
 ** [Class CxObjGenericView]
 **  Method smallIcon(): Return this object's Small icon.
 **  Method desktopIcon(): Return this object's Normal icon.
 **  Method objectMenu(): Return this object's menu (the M_OBJECT menu).
 **  Method objectName(): Return this object's title/name.
 **  Method refresh(): Refresh the contents of the current object.
 **  Method clear(): Clear the contents of the current object.
 **/
class		CxObjGenericView: 
		public QHBox {
Q_OBJECT

public:
				CxObjGenericView(QWidget *parent);

 virtual QPixmap		CxSmallIcon() = 0;
 virtual QPixmap		CxDesktopIcon() = 0;
 virtual QPopupMenu*		CxObjectMenu() = 0;
 virtual QString		CxObjectName() = 0;
 virtual KToolBar*		CxToolbar() = 0;

public slots:
 virtual	void		refresh() = 0;
 virtual	void		clear() = 0;
};

#endif
