/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/objmesgpane.o
 ** Date: 2000-12-18
 ** Last Revision: 2000-12-18
 ** Description: Message Pane component.
 ** CVS: $Id: objmesgpane.cpp,v 1.9 2001/07/25 02:22:11 brian Exp $
 **/
#define         __CX_SOURCEFILE__
#include        <unistd.h>
#include        <stdlib.h>
#include        <stdio.h>
#include        <string.h>
#include        <iostream.h>
#include        <qlayout.h>
#include        <qframe.h>
#include        <qvbox.h>
#include        <qevent.h>
#include        <kapp.h>
#include        <kdialog.h>
#include        <klocale.h>
#include        <kglobal.h>
#include        <khtml_part.h>
#include        <khtmlview.h>
#include        <CxClient.h>
#include	"autoconf.h"
#include	"objmesgpane.h"

/**
 ** CxObjMesgPane::CxObjMesgPane(): Generate a new Message Pane.
 **/
		CxObjMesgPane::CxObjMesgPane(QWidget *parent): 
		QVBox(parent) {

	setFrameShape( QFrame::WinPanel );
	setFrameShadow( QFrame::Sunken );

	i_header = new QVBox(this);
	i_header->setMargin(KDialog::marginHint());
	i_header->setSpacing(KDialog::spacingHint());
	i_header->setFrameShape( QFrame::WinPanel );
	i_header->setFrameShadow( QFrame::Raised );
	is_header_visible = true;

	QHBox *hbFrom = new QHBox(i_header); 
	QLabel *lblFrom = new QLabel(hbFrom);
	lblFrom->setText(QString("From:  "));
	lblFrom->setFont(QFont("helvetica", 10, QFont::Bold));
	lblFrom->setAlignment(AlignRight);
	hbFrom->setStretchFactor(lblFrom, 7);

	msgFrom = new QLabel(hbFrom);
	msgFrom->setText(QString::null);
	msgFrom->setFont(QFont("helvetica", 10));
	hbFrom->setStretchFactor(msgFrom, 93);
 
	QHBox *hbTo = new QHBox(i_header); 
	QLabel *lblTo = new QLabel(hbTo);
	lblTo->setText(QString("To:  "));
	lblTo->setAlignment(AlignRight);
	lblTo->setFont(QFont("helvetica", 10, QFont::Bold));
	hbTo->setStretchFactor( lblTo, 7 );

	msgTo = new QLabel(hbTo);
	msgTo->setText(QString::null);
	msgTo->setFont(QFont("helvetica", 10));
	hbTo->setStretchFactor( msgTo, 93 );

	QHBox *hbSubj = new QHBox(i_header); 
	QLabel *lblSubj = new QLabel(hbSubj);
	lblSubj->setText(QString("Subject:  "));
	lblSubj->setAlignment(AlignRight);
	lblSubj->setFont(QFont("helvetica", 10, QFont::Bold));
	hbSubj->setStretchFactor( lblSubj, 7 );
 
	msgSubj = new QLabel(hbSubj);
	msgSubj->setText(QString::null);
	msgSubj->setFont(QFont("helvetica", 10));
	hbSubj->setStretchFactor( msgSubj, 93 );
       
	msgBody = new KHTMLPart( this, "mesgPaneText");
	msgBody->view()->setFrameShape( QFrame::NoFrame );
	msgBody->setJavaEnabled( false );
	msgBody->setJScriptEnabled( false );
	msgBody->enableMetaRefresh( false );
	msgBody->setDNDEnabled( false );
	msgBody->enablePlugins( false );
	msgBody->setStandardFont("helvetica");
	msgBody->show();

	clear();
}

/**
 ** CxObjMesgPane::slotLoadMesg(): Update the message pane information.
 **/
void		CxObjMesgPane::slotLoadMesg(const QString &from, const QString &to, const QString &subj, const QString &body) {

	emit msgFrom->setText(from);
	emit msgTo->setText(to);
	emit subj.isNull()?msgSubj->setText(subj):msgSubj->setText(i18n("(No Subject)"));

	msgBody->begin();
	msgBody->write(body);
	msgBody->end();
}

/**
 ** ObjMesgPane::clear(): Clear the message pane.
 **/
void		CxObjMesgPane::clear() {

	msgFrom->setText(QString::null);
	msgTo->setText(QString::null);
	msgSubj->setText(QString::null);

	// Message Body
	msgBody->openURL( KURL("file:/usr/local/share/apps/infusion/about/intro.html") );
}
