/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objtasklist.o
 ** Date: 2001-01-18
 ** Last Revision: 2001-01-18
 ** Description: Task list component.
 ** CVS: $Id: objtasklist.cpp,v 1.13 2001/08/28 01:21:35 brian Exp $
 **/
#include        <stdlib.h>
#include        <iostream.h>
#include        <qdatetime.h>
#include        <qlayout.h>
#include        <qtable.h>
#include        <qhbox.h>
#include        <kapp.h>
#include        <kglobal.h>
#include        <kdebug.h>
#include        <dcopclient.h>
#include        <kmessagebox.h>
#include        <kiconloader.h>
#include        <CxClient.h>
#include	"objtasklist.h"
#include	"wndmain.h"
#include	"wndtask.h"
#include	"rfc2426t.h"

#include	"icons/tasks_16x16.xpm"
#include	"icons/checkbox_off_16x16.xpm"
#include	"icons/checkbox_on_16x16.xpm"
extern CxWndMain *wndMain;

/**
 ** CxObjTasklist::CxObjTasklist(): Constructor.
 **/
		CxObjTasklist::CxObjTasklist(QWidget *parent, int mode, const QString& searchSpec, const char *name): 
		QListView(parent, name) {

	if(mode) ;
	if(name) ;
	if(searchSpec) ;

	connect(this, SIGNAL(clicked( QListViewItem* )), SLOT(slotSelected( QListViewItem* )));
	connect(this, SIGNAL(doubleClicked( QListViewItem* )), SLOT(slotOpenItem( QListViewItem* )));

	setAllColumnsShowFocus( true );
	setFrameStyle(QFrame::WinPanel + QFrame::Sunken);
	addColumn(QString::null);
	addColumn(QString::null);
	addColumn(QString::null);
	addColumn(QString::null);
	addColumn(QString("Subject"));
	addColumn(QString("Due Date"));
	setColumnWidth(0,0);
	setColumnWidth(1,0);
	setColumnWidthMode(0,Manual);
	setColumnWidthMode(1,Manual);

	connect( this, SIGNAL(rightButtonPressed(QListViewItem *, const QPoint &, int)), this, SLOT(rmbClicked(QListViewItem *, const QPoint &, int)) );

	m_NoItem = new QPopupMenu(this);
	m_NoItem->insertItem(SmallIcon(QString("klipper")), QString("New &Task..."), this, SLOT(slotNewTask()));

	m_Item = new QPopupMenu(this);
	m_Item->insertItem(QString("&Open"), NULL);
	m_Item->insertSeparator();
	m_Item->insertItem(QString("For&ward"), NULL);
	m_Item->insertSeparator();
	m_Item->insertItem(QString("Assi&gn Task"), NULL);
	m_Item->insertItem(QString("&Mark Complete"), NULL);
	m_Item->insertItem(QString("S&end Status Report"), NULL);
	m_Item->insertSeparator();
	m_Item->insertItem(QString("&Delete"), NULL);

	_TaskList = 0;
}

/**
 ** CxObjTasklist::refresh(): Refresh the user listing.  This will behave
 ** differently depending on which mode the selector is in.
 **/
void		CxObjTasklist::refresh() {
CXLIST		x;
QListViewItem 	*i;
ROOMINFO	*ri;
char            buf[255];
char		*tmp[20];
QDateTime       td;
QCString	replyType;
QByteArray	replyData;

	return;

	kdDebug() << "CxObjTasklist::refresh()" << endl;
	clear();
        
	QByteArray data;
	QDataStream arg(data, IO_WriteOnly);
	arg << false;
	arg << QCString("My Tasks");

	/**
	 ** infusiond maintains the network connection, so we should
	 ** retrieve a list of messages from it.
	 **/
	kdDebug() << "CxObjTasklist::refresh(): ->DCOP" << endl;
	if(kapp->dcopClient()->call("infusiond", "CxMessenger", "fetchMessageList(bool,QCString)", data, replyType, replyData)) {

		kdDebug() << "CxObjTasklist::refresh(): <-DCOP" << endl;
		QDataStream reply(replyData, IO_ReadOnly);
		if (replyType == "QCStringList" ) {
			QCStringList result;
			char *tmp[20];
			reply >> result;

			QCStringList::Iterator resi;
			for( resi = result.begin(); resi != result.end(); ++resi) {
				QCString	replyType2;
				QByteArray	replyData2;

				kdDebug() << "CxObjTasklist::refresh(): resi: " << (*resi) << endl;
				strcpy(buf, (*resi));

				CxSerialize( buf, (char **)&tmp );
				td.setTime_t(atoi(tmp[3]));

				bool subj_is_null = false;
				if(!strcmp(tmp[4],"(null)")) subj_is_null = true;
				else if(!tmp[4][0] || !tmp[4]) subj_is_null = true;

	        		QByteArray data2;
			        QDataStream arg2(data, IO_WriteOnly);
				arg2 << QCString("My Tasks");
				arg2 << QString(tmp[0]).toULong();
 
				/**
				 ** Load the requested message from the Infusion Daemon.  If the
				 ** message could not be open, abort bootstrap and display an error
				 ** message.  (Then, close)
				 **/
				kdDebug() << "CxObjTasklist::refresh(): -> ***************** Get message --" << QCString("My Tasks") << ":" << atol(tmp[0]) << endl;
	/**
				if(kapp->dcopClient()->call( "infusiond", "CxMessenger", "fetchMessage(QCString, unsigned long int)", 
					data2, replyType2, replyData2)) {
 
					QDataStream reply2(replyData2, IO_ReadOnly);
					if(replyType2 == "QCStringList" ) {
						int     elements = 0;
						QCStringList mesgInfo;
						QString	g_MessageBody;
						reply >> mesgInfo;
 
						kdDebug() << "CxObjTasklist::refresh(): <- ***************** GOT message" << endl;
						QCStringList::Iterator x;
						int field = 0;
						for(x = mesgInfo.begin(); x != mesgInfo.end(); ++x) {
							switch(field) {
								case(6): g_MessageBody = (*x); break;
								default: break;
							}
							++field;
						}
						Rfc2426t *t = new Rfc2426t(g_MessageBody);
						if(t) {
							i = new QListViewItem(this, 
								QString( (((t->getStatus())==100)?"1":"0") ),
								QString(tmp[0]),
								QString::null,
								QString::null,
								t->getSubject(),
								QString("01/01 01:01"));
							i->setPixmap(2, QPixmap(tasks_16x16_xpm));
							i->setPixmap(3, 
								QPixmap( (((t->getStatus()==100)?checkbox_on_16x16_xpm:checkbox_off_16x16_xpm) ))
							);

							delete t;
						}
					}
				}
	**/
			}
		}
	}

/**
 ** OLD heavy-client code.
 **
	ri = CxRmGoto(wndMain->getHndl(), "My Tasks",0);
        if(ri) {
		free(ri);
		if(_TaskList) _TaskList = CxLlFlush(_TaskList);

		_TaskList = CxMsList(wndMain->getHndl(), MSGS_ALL, 0);
		x = _TaskList;
		while(x) {
			MESGINFO msg;
			msg.body = 0;

			if(!CxMsLoad(wndMain->getHndl(), atol(x->data), 0, &msg)) {
				Rfc2426t *t = new Rfc2426t(msg.body);

				if(t) {
					i = new QListViewItem(this, 
						QString( (((t->getStatus())==100)?"1":"0") ),
						QString(x->data),
						QString::null,
						QString::null,
						t->getSubject(),
						QString("01/01 01:01"));
					i->setPixmap(2, QPixmap(tasks_16x16_xpm));
					i->setPixmap(3, 
						QPixmap( (((t->getStatus()==100)?checkbox_on_16x16_xpm:checkbox_off_16x16_xpm) ))
					);

					delete t;
				}
				free(msg.body);
			}

			x = x->next;
		}

		ri = CxRmGoto(wndMain->getHndl(), wndMain->getRoomName(), 0);
		free(ri);

	} else {
                ROOMINFO nri;
                strcpy(nri.name, "My Tasks");
                nri.mode = 4;
                nri.floor_id = 0;
 
                if(CxRmCreate(wndMain->getHndl(), nri)) {
                }
	}
 **/
}

/**
 ** CxObjTasklist::selectedItem(): Return a pointer to the selected row.
 **/
void		CxObjTasklist::slotSelected(QListViewItem *i) {

	if(!i) return;

	if(i->text(0)=="1") {
		i->setText(0, QString("0"));
		i->setPixmap(3,QPixmap(checkbox_off_16x16_xpm));
	} else {
		i->setText(0, QString("1"));
		i->setPixmap(3,QPixmap(checkbox_on_16x16_xpm));
	}
}

/**
 ** CxObjTasklist::slotNewTask(): Popup new task window.
 **/
void		CxObjTasklist::slotNewTask() {

	CxWndTask *task = new CxWndTask(1);
	task->show();
}

/**
 ** CxObjTasklist::slotLoadTask(): OPEN A TASK.
 **/
void		CxObjTasklist::slotLoadTask(const QString& task_id) {
ROOMINFO	*rmb = 0;
MESGINFO	msg;

	if(wndMain->getRoomName() != "My Tasks") {
		rmb = CxRmGoto(wndMain->getHndl(), "My Tasks",0);
	}

	msg.body = 0;

	if(!CxMsLoad(wndMain->getHndl(), atol(task_id), 1, &msg)) {
		Rfc2426t *t = new Rfc2426t(msg.body);

		if(t) {

			CxWndTask *taskwin = new CxWndTask(0, t);
			taskwin->show();

			delete t;
		}
		free(msg.body);
	}
	

	if(rmb) {
		free(rmb);
		rmb = CxRmGoto(wndMain->getHndl(), wndMain->getRoomName(),0);
		free(rmb);
	}
}

/**
 ** CxObjTasklist::slotOpenItem(): OPEN A TASK.
 **/
void		CxObjTasklist::slotOpenItem(QListViewItem *item) {

	emit slotLoadTask(item->text(1));
}

/**
 ** CxObjTasklist::rmbClicked(): What happens when a user right-clicks?  (CONTEXT-SENSITIVE MENU)
 **/
void		CxObjTasklist::rmbClicked(QListViewItem *item, const QPoint &pt, int x) {

	if(x) ;
	if(!item) {
		m_NoItem->popup(pt);
		return;

	} else {
		emit QListView::selectionChanged(item);
		m_Item->popup(pt);
		return;
	}
}
