/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/objtitlebar.o
 ** Date: 2000-12-18
 ** Last Revision: 2000-12-18
 ** Description: Title Bar component.
 ** CVS: $Id: objtitlebar.cpp,v 1.2 2001/02/19 21:58:44 brian Exp $
 **/
#define         __CX_SOURCEFILE__
#include        <iostream.h>
#include        <kiconloader.h>
#include        <qframe.h>
#include        <qlabel.h>
#include        <qbutton.h>
#include        <qpixmap.h>
#include        <qpalette.h>
#include        <kiconloader.h>
#include        <CxClient.h>
#include	"objtitlebar.h"

/**
 ** CxObjTitleBar::CxObjTitleBar(): Generate a new IconView containing notes.
 **/
		CxObjTitleBar::CxObjTitleBar(QWidget *parent): 
		QFrame( parent, "wndNote", WStyle_Customize|WStyle_NoBorderEx|WDestructiveClose ) {

	setFrameStyle(QFrame::NoFrame);
	QPalette stdpalette = palette();
	QColor bgc = stdpalette.color(QPalette::Active, QColorGroup::Background).dark(120);
	QColor fgc = Qt::white;
	stdpalette.setColor(QColorGroup::Background, bgc);
	stdpalette.setColor(QColorGroup::Base, bgc);
	stdpalette.setColor(QColorGroup::Foreground, fgc);
	stdpalette.setColor(QColorGroup::Text, fgc); 
	setPalette(stdpalette);

	g_titlebtn = new QButton(this);
	connect(g_titlebtn, SIGNAL(clicked()), this, SLOT(slotTitleClicked()));
	g_title = new QLabel(g_titlebtn);
	g_title->setAutoMask(true);
	g_title->setFont(QFont("Times", 18, QFont::Bold));
	g_title->setText(QString("Hello, World!"));
	g_title->show();
	
	g_iconctr = new QLabel(this);
	g_iconctr->setPixmap(DesktopIcon(QString("mail_generic"),32));

	resize(300,37);
	setFixedHeight(37);
}

/**
 ** CxObjTitleBar::resizeEvent(): What happens when we're told to resize ourselves?
 **/
void		CxObjTitleBar::resizeEvent(QResizeEvent *qre) {

        QFrame::resizeEvent( qre );
 
        int new_height = height();
        int new_width = width();
        int iconWidth = 32; //g_iconctr->width();

	g_title->setGeometry( 5, 0, new_width - iconWidth, new_height);
	g_titlebtn->setGeometry( 5, 0, new_width - iconWidth, new_height);
	g_iconctr->setGeometry( new_width-iconWidth-5, 0, new_width, new_height);
}

/**
 ** CxObjTitleBar::slotSetTitle(): Set the current title of the titlebar.
 **/
void		CxObjTitleBar::slotSetTitle(const QString& t) {
	g_title->setText(t);
}

/**
 ** CxObjTitleBar::slotSetIcon(): Set the current titlebar icon.
 **/
void		CxObjTitleBar::slotSetIcon(const QPixmap &icon) {
	g_iconctr->setPixmap(icon);
}

/**
 ** CxObjTitleBar::slotTitleClicked(): Someone clicked the title!
 **/
void		CxObjTitleBar::slotTitleClicked() {
	emit title_clicked();
}

/**
 ** CxObjTitleBar::slotUpdate(): Change the attributes of this titlebar.
 **/
void		CxObjTitleBar::slotUpdate(const QString& title, const QPixmap& icon) {
	emit slotSetTitle(title);
	emit slotSetIcon(icon);
}
