/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/objuserlist.o
 ** Date: 2000-12-11
 ** Last Revision: 2000-12-11
 ** Description: Addressbook component.
 ** CVS: $Id: objuserlist.cpp,v 1.8 2001/08/28 01:21:35 brian Exp $
 **/
#include        <unistd.h>
#include        <stdlib.h>
#include        <stdio.h>
#include        <string.h>
#include        <iostream.h>
#include        <qlayout.h>
#include        <qevent.h>
#include        <qhbox.h>
#include        <qlist.h>
#include        <qsplitter.h>
#include        <kapp.h>
#include        <kglobal.h>
#include        <kmessagebox.h>
#include        <ktabctl.h>
#include        <klistview.h>
#include        <CxClient.h>
#include	"wndmain.h"
#include	"objuserlist.h"

/**
 ** CxObjUserlist::CxObjUserlist(): CONSTRUCTOR.
 **/
		CxObjUserlist::CxObjUserlist(QWidget *parent, int mode, const QString& searchSpec, const char *name): 
		QWidget(parent, name) {

	if(searchSpec); 

        tabs = new QVBox(this);
	tabs->setSpacing(10);

	whichList = new QComboBox(tabs);
	whichList->insertItem(QString("Online Users"));
	whichList->insertItem(QString("Global Address List"));
	whichList->insertItem(QString("Personal Address List"));
	whichList->setCurrentItem(mode);
	connect(whichList, SIGNAL(activated(int)), SLOT(refreshList(int)));

	i_widgetStack = new QWidgetStack( tabs );
 
	g_onlineUsers = new KListView(tabs);
	g_onlineUsers->setAllColumnsShowFocus(true);
        g_onlineUsers->setFrameStyle(QFrame::WinPanel + QFrame::Sunken);
        g_onlineUsers->setSorting(1);
        g_onlineUsers->addColumn("");
        g_onlineUsers->addColumn("Username");
        g_onlineUsers->addColumn("Room");
        g_onlineUsers->addColumn("From Host");
        g_onlineUsers->addColumn("Client");
	i_widgetStack->addWidget( g_onlineUsers, 0 );
	g_onlineUsers->show();

	g_allUsers = new KListView(tabs);
	g_allUsers->setAllColumnsShowFocus(true);
        g_allUsers->setFrameStyle(QFrame::WinPanel + QFrame::Sunken);
        g_allUsers->setSorting(1);
        g_allUsers->addColumn("");
        g_allUsers->addColumn("Username");
        g_allUsers->addColumn("Real Name");
        g_allUsers->addColumn("E-mail Address");
        g_allUsers->addColumn("Online?");
	i_widgetStack->addWidget( g_allUsers, 1 );
	g_allUsers->hide();


	resize(400,300);
	i_widgetStack->raiseWidget( g_onlineUsers );
//	emit refreshList(mode);
}

/**
 ** CxObjUserlist::refreshList(): Refresh the user listing.  This will behave
 ** differently depending on which mode the selector is in.
 **/
void		CxObjUserlist::refreshList(int mode) {

	switch(mode) {

		// Mode 0: ONLINE USERS
		case(0):
/*
			if((users = CxUsOnline(0))) {
				g_onlineUsers->clear();
				t = users;
				while(t) {
					CxSerialize(t->data, (char **)g_Ser);
					i  = new QListViewItem(g_onlineUsers, g_Ser[0], g_Ser[1], g_Ser[2], g_Ser[3]);
					t = t->next;
				}
				users = CxLlFlush(users);
			}
 */
			i_widgetStack->raiseWidget( g_onlineUsers );
			break;

		// Mode 1: GLOBAL ADDRESS BOOK
		case(1):

/*
			if((users = CxUsList())) {
				t = users;
				while(t) {
					CxSerialize(t->data, (char **)g_Ser);
					i  = new QListViewItem(g_onlineUsers, g_Ser[1], g_Ser[0], g_Ser[2], g_Ser[3]);
					t = t->next;
				}
				users = CxLlFlush(users);
			}
 */
			i_widgetStack->raiseWidget( g_allUsers );
			break;

		// Mode 2: PERSONAL ADDRESS BOOK
		case(2):
		default:
			break;
	}
}

void 		CxObjUserlist::resizeEvent( QResizeEvent *newSize) {
	QWidget::resizeEvent(newSize);
	resize(newSize->size().width(), newSize->size().height());
	tabs->resize(newSize->size().width(), newSize->size().height());
	g_onlineUsers->resize(newSize->size().width(), newSize->size().height());
}

/**
 ** CxObjUserlist::selectedItem(): Return a pointer to the selected row.
 **/
QListViewItem 		*CxObjUserlist::selectedItem() {
	return(g_onlineUsers->currentItem());
}

/**
 ** CxObjUserlist::slotPopulateOnline(): Populate the online user list.
 **/
void		CxObjUserlist::slotPopulateOnline( QList<QString> items ) {
QListIterator<QString> i(items);
QListViewItem 	*newitem;
char		*g_Ser[20];

	g_onlineUsers->clear();
	for(; QString *mi = i.current(); ++i) {
		char* x;
		x = strdup( mi->ascii() );
		CxSerialize(x, (char **)g_Ser);

		newitem = new QListViewItem(g_onlineUsers, 
				g_Ser[0], 	// Session ID
				g_Ser[1], 	// Username
				g_Ser[2], 	// Room
				g_Ser[3], 	// Host
				g_Ser[4]);	// Client
		free( x );
	}
		
}

/**
 ** CxObjUserlist::slotPopulateUsers(): Populate the Global Address List.
 **/
void		CxObjUserlist::slotPopulateUsers( QList<QString> items ) {
QListIterator<QString> i(items);
QListViewItem 	*newitem;
char		*g_Ser[20];

	g_allUsers->clear();
	for(; QString *mi = i.current(); ++i) {
		char* x;
		x = strdup( mi->ascii() );
		CxSerialize(x, (char **) g_Ser);
		newitem = new QListViewItem(g_allUsers, QString::null, g_Ser[0], g_Ser[1], g_Ser[2], g_Ser[3]);
		free( x );
	}
}
