/**
 ** Object for handling RFC2426T objects ("vTasks")
 ** Written by B. Ledbetter (brian@shadowcom.net)
 ** Copyright (c) 2000, Flaming Sword Productions
 **
 ** $Id: rfc2426t.h,v 1.4 2001/09/08 02:06:14 brian Exp $
 **/
#ifndef		__RFC2426T_H__
#define		__RFC2426T_H__
#include	<qstring.h>

class		Rfc2426t {

public:
			// Create object from text stream.
			Rfc2426t(const QString& = NULL, const QString& = NULL, const QString& = NULL );
			~Rfc2426t();

inline	QString		getSubject() { return(d_Name.copy()); };
inline	QString		getDetails() { return(d_Details.copy()); };
inline	int		getStatus() { return((int)(d_Pct*100)); };

inline	void		setStatus(float pct) { d_Pct = pct; };
inline	void		setSubject(const QString &n) { d_Name = n.copy(); };
inline	void		setDetails(const QString &d) { d_Details = d.copy(); };

	QString		export_ascii();

private:

	void		parser();


	QString		*o_data,	// Raw, unmolested object data.

			/**
			 ** These data elements are part of the
			 ** VTASK RFC.
			 **/
			d_Name,	// Task name
			d_Details;	// Task details
	float		d_Pct;		// Percentage completed

};

#endif
#define _x_ const char
