/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: wndaction.o
 ** Date: 2000-11-10
 ** Last Revision: 2001-01-09
 ** Description: Login status message handler.
 ** CVS: $Id: wndaction.cpp,v 1.12 2001/08/28 01:21:35 brian Exp $
 **/
#include	<qapplication.h>
#include	<qvbox.h>
#include	<qhbox.h>
#include	<qtimer.h>
#include	<qpalette.h>
#include	<kwin.h>
#include	<kdialog.h>
#include	<kiconloader.h>
#include	"icons/splash_screen.xpm"
#include	"wndaction.h"

/**
 ** I've once again left the Icon motif behind.  Don't be 
 ** afraid, it'll be back...
 **/

/**
 ** CxWndAction::CxWndAction(): Constructor.
 **/
		CxWndAction::CxWndAction() 
		:KMainWindow( 0, "wndAction", WType_TopLevel|WStyle_NoBorder|WStyle_StaysOnTop|WDestructiveClose) {
QPixmap		splash(splash_screen_xpm);

	KWin::setState( winId(), NET::StaysOnTop | NET::SkipTaskbar );
	KWin::setIcons( winId(), DesktopIcon(QString("gear")), SmallIcon(QString("gear")));
	KWin::setActiveWindow( winId() );
	KWin::setType( winId(), NET::Override );

	QHBox *page = new QVBox(this, "wndActionBox");
	page->setSpacing( 0 );
	page->setMargin( 1 );

	QPalette stdpalette = palette();
	QColor bgc = Qt::black;
	QColor fgc = Qt::white;
	stdpalette.setColor(QColorGroup::Background, bgc);
	stdpalette.setColor(QColorGroup::Base, bgc);
	stdpalette.setColor(QColorGroup::Foreground, fgc);
	stdpalette.setColor(QColorGroup::Text, fgc);
	setPalette(stdpalette);

	QLabel *logo = new QLabel( page );

	logo->setPixmap( splash );
	logo->show();
	logo->setFixedWidth(splash.width());
	page->setFixedWidth( splash.width()+2 );

	statusMsg = new QLabel( page );
	statusMsg->setAlignment( AlignCenter );
	statusMsg->setText( QString("Please wait, starting Infusion...") );
	statusMsg->setFont( QFont("lucida",10) );
	page->setFixedHeight( splash.height() + statusMsg->height() + 2);

	setCentralWidget( page );
	resize( page->width(), page->height() );

	int W = QApplication::desktop()->width();
	int H = QApplication::desktop()->height();
	int w = page->width();
	int h = page->height();

	move( ((W/2)-(w/2)), ((H/2)-(h/2)) );

	feeldead = 0;

	QTimer::singleShot(1, this, SLOT(initializeStatus()));
}

/**
 ** CxWndAction::Destruct(): Prepare this window for destruction.
 **/
		CxWndAction::~CxWndAction() {

	feeldead = 1;
}

/**
 ** CxWndAction::updateStatusMsg(): Update status text.
 **/
void		CxWndAction::updateStatusMsg(const QString &msg) {

	emit statusMsg->setText( msg );

}

/**
 ** CxWndAction::updateStatus(): Update status.
 **/
void		CxWndAction::updateStatus(int pct, const QString& msg) {

	if(pct) ;

	emit updateStatusMsg(msg);
}

/**
 ** CxWndAction::initializeStatus(): Initialize this window.
 **/
void		CxWndAction::initializeStatus() {

	emit updateStatus(2, "Connecting to Citadel/UX...");
}

