/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: wndlogin.o
 ** Date: 2000-10-15
 ** Last Revision: 2000-01-08
 ** Description: Login dialog box.
 ** CVS: $Id: wndlogin.cpp,v 1.5 2001/07/25 02:22:13 brian Exp $
 **/
extern "C" {
#include	<unistd.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
};
#include	<iostream.h>
#include	<kmessagebox.h>
#include	<ktabctl.h>
#include	<kiconloader.h>
#include	<klocale.h>
#include	<kwin.h>
#include	<kcontainer.h>
#include	<qcheckbox.h>
#include	<qlayout.h>
#include	<qlabel.h>
#include	<CxClient.h>
#include	"wndlogin.h"
#include	"wndmain.h"
#include	"wndaction.h"
#include	"wndnewaccount.h"

extern CxWndMain *wndMain;
CxWndAction	*wndAction = 0;

/**
 ** savePw(): Save a username/password combo into ~/.infusion.rc
 **/
void		savePw(const QString &hn, const QString& un, const QString& pw) {
int		fh;
char		fil[255];
CXCONFIG	conf;

	sprintf(fil, "%s/.infusion.rc", getenv("HOME"));
	cerr << "STORING PASSWORD IN INSECURE FORM!  PLEASE PROTECT THIS FILE: " << fil << endl;
	if((fh = open(fil, O_RDWR|O_CREAT, 0600))) {

		strcpy(conf.stored_host, hn.ascii());
		strcpy(conf.stored_user, un.ascii());
		strcpy(conf.stored_pass, pw.ascii());
		write(fh, &conf, sizeof(conf));
		close(fh);
	}
}

/**
 ** CxWndLogin::Constructor()
 **/
		CxWndLogin::CxWndLogin(KApplication *parent, const QString& caption) : 
			KDialogBase(
				0, 
				"dlgLogin",
				TRUE,
				caption,
				Ok|Cancel|User1,
				Ok,
				TRUE,
				QString("&New Account")
			) {

	if(parent) ;
	cached_pw_inf = 0;
	KWin::setIcons(winId(), DesktopIcon(QString("password")), SmallIcon(QString("password")));

	setCaption(QString("Login"));

	KTabCtl *tabs = new KTabCtl(this);
	setMainWidget(tabs);

	QWidget	*page = new QWidget(tabs);
	tabs->addTab(page, QString("Login"));

	QGridLayout *topLayout = new QGridLayout(page,4,2,marginHint(),spacingHint(),"wndLoginGrid");

	QLabel *icon = new QLabel(page);
	icon->setPixmap(DesktopIcon(QString("password"),32));
	icon->setAlignment(AlignCenter);
	topLayout->addWidget(icon, 1,1,0);

	QLabel *mytext = new QLabel(page);
	mytext->setText(QString("Please log in to Citadel."));
	topLayout->addWidget(mytext, 1,2,0);
	
	QLabel *label1 = new QLabel(QString("Username:"),page,"wndLoginLbl1");
	topLayout->addWidget(label1, 2,1,0);

	leUsername = new KLineEdit(page, "wndLoginUn");
	topLayout->addWidget(leUsername,2,2,0);

	QLabel *label2 = new QLabel(QString("Password:"),page,"wndLoginLbl2");
	topLayout->addWidget(label2,3,1,0);

	lePassword = new KLineEdit(page, "wndLoginPw");
	lePassword->setContextMenuEnabled( false );
	lePassword->setEchoMode(QLineEdit::Password);
	topLayout->addWidget(lePassword,3,2,0);

	c_savepw = new QCheckBox(QString("Save Password"), page);
	c_savepw->setChecked(true);
	topLayout->addWidget(c_savepw,4,2,0);

	leUsername->setFocus();

	QWidget	*page2 = new QWidget(tabs);
	tabs->addTab(page2, QString("Options"));
	QGridLayout *optLayout = new QGridLayout(page2,1,2,marginHint(),spacingHint(),"wndLoginGrid");
	optLayout->setOrigin(QGridLayout::TopLeft);

	QLabel *label3 = new QLabel(QString("Server Name:"),page2,"wndLoginLbl0");
	optLayout->addWidget(label3,1,1,0);

	leHostname = new KLineEdit(QString("localhost"), page2, "wndLoginHn");
	optLayout->addWidget(leHostname,1,2,0);

	resize(370,220);

	emit slotLoadPw();
}

/**
 ** CxWndLogin::closeEvent(): What do we do when we exit?
 **/
void 		CxWndLogin::closeEvent(QCloseEvent *) {

//	delete(this);
	this->hide();
}

/**
 ** CxWndLogin::slotOk(): I'm outta here!
 **/
void		CxWndLogin::slotOk() {
USERINFO	*user_info;
QString		t;
int		i = 0;


	if(!(wndMain->isConnected())) {
		t = leHostname->text();
		i = CxClConnection( t.ascii(), 504, leUsername->text(), lePassword->text());
		wndMain->setHndl(i);
		if(CxClConnect(i)) {
			KMessageBox::sorry(this, 
				QString("The server could not be contacted."),
				QString("Unable to Connect!"),
				false
			);
			CxClDelete( i );
		} else {
			wndMain->setConnected(1);
		}
	}

	if((user_info = CxUsAuth(i,NULL,NULL))) { //leUsername->text(), lePassword->text()))) {

		wndMain->setUserName(QString(user_info->username));
		free(user_info);

		wndAction = new CxWndAction();
		wndAction->show();

		wndMain->setStatusMsg(QString("Welcome, ")+leUsername->text()+QString("!"));

		QTimer::singleShot(1, this, SLOT(hide()));
		QTimer::singleShot(600, wndMain, SLOT(initializeClient()));
		QTimer::singleShot(700, this, SLOT(close()));

		if(((c_savepw->isChecked()) == true) && (!cached_pw_inf)) {
			emit slotSavePw();
		}

	} else {
		KMessageBox::sorry(this, 
			QString("The username or password specified is incorrect."), 
			QString("Invalid Login!"),
			false
		);
	}
}

/**
 ** CxWndLogin::slotUser1(): Show New Account Wizard
 **/
void		CxWndLogin::slotUser1() {
	CxWndNewAcct *wndNewAcct = new CxWndNewAcct();
	wndNewAcct->show();
	close();
}

/**
 ** CxWndLogin::slotSavePw(): Trigger a store event.
 **/
void		CxWndLogin::slotSavePw() {
	savePw(leHostname->text(), leUsername->text(), lePassword->text());
}

/**
 ** CxWndLogin::slotLoadPw(): Attempt to load the user's stored password from ~/.infusion.rc
 **/
void		CxWndLogin::slotLoadPw() {
int		fh, i;
char		fil[255];
CXCONFIG	conf;

	sprintf(fil, "%s/.infusion.rc", getenv("HOME"));
	if((fh = open(fil, O_RDONLY))) {
		i = read(fh, &conf, sizeof(conf));
		if(i == sizeof(conf)) {
			cached_pw_inf = 1;
			leHostname->setText(conf.stored_host);
			leUsername->setText(conf.stored_user);
			lePassword->setText(conf.stored_pass);
			emit slotOk();
		}
	}
}

/**
 ** CxWndLogin::slotExit(): I'm outta here!
 **/
void		CxWndLogin::slotExit() {

	close();
}
