/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/wndmain.c
 ** Date: 2000-11-09
 ** Last Revision: 2000-11-09
 ** Description: Main user interface window.
 ** CVS: $Id: wndmain.cpp,v 1.24 2001/09/08 02:14:55 brian Exp $
 **/
#include	<unistd.h>
#include	<stdlib.h>
#include	<iostream.h>
#include	<qlayout.h>
#include	<qframe.h>
#include	<qwidgetstack.h>
#include	<qdatetime.h>
#include	<qsplitter.h>
#include	<kapp.h>
#include	<kaccel.h>
#include	<kglobal.h>
#include	<klocale.h>
#include	<kdebug.h>
#include	<kmessagebox.h>
#include	<dcopclient.h>
#include	<kiconloader.h>
#include	<kstddirs.h>
#include	<ktoolbarbutton.h>
#include	<kconfig.h>
#include	<knotifyclient.h>
#include	<kparts/factory.h>
#include	<kwin.h>
#include	<CxClient.h>
#include	"autoconf.h"
#ifdef		HAVE_KOOLBAR
#include	"koKoolBar.h"
#endif
#include	"objtitlebar.h"
#include	"objuserlist.h"
#include	"objnotesview.h"
#include	"objtasksview.h"
#include	"objaddrbookview.h"
#include	"objexternalview.h"
#include	"objnote.h"
#include	"wndabout.h"
#include	"wndaction.h"
#include	"wndlogin.h"
#include	"wndmesg.h"
#include	"wndtask.h"
#include	"wndmain.h"

#include	"icons/folder_32x32.xpm"

#define		ID_NEW		1
#define		ID_NEXT		2
#define		ID_REFRESH	3
#define		ID_BUDDYLIST	4

extern KApplication* g_InfusionApp;

/**
 ** These are our _compiled-in_ ui components.
 **/
extern		CXOBJDEF	CXINBOX;
extern		CXOBJDEF	CXTRASH;
extern		CXOBJDEF	CXCALENDAR;
extern		CXOBJDEF	CXNOTES;
extern		CXOBJDEF	CXTASKS;
extern		CXOBJDEF	CXCONTACTS;

extern	CxWndAction	*wndAction;

/**
 ** CxWndMain::Constructor()
 **/
		CxWndMain::CxWndMain() : KMainWindow() {
int		i;

	dcop = g_InfusionApp->dcopClient();
	dcop->attach();

	KWin::setIcons(winId(), DesktopIcon("infusion"), SmallIcon(QString("infusion")));
	Room[0] = Connected = 0;
	_RoomIndex = _FloorIndex = 0;

	setCaption(QString::null);
	setMinimumSize(300,100);

	KAccel *keys = new KAccel(this);
	keys->connectItem(KStdAccel::New, this, SLOT(slotNewMessage()));
	keys->connectItem(KStdAccel::Quit, this, SLOT(slotExit()));
	keys->insertItem(QString("Refresh"), "Refresh", Key_F5);
	keys->insertItem(QString("AboutApp"), "AboutApp", CTRL+Key_A);
	keys->insertItem(QString("Disconnect"), "Disconnect", CTRL+Key_D);
	keys->insertItem(QString("Inbox"), "Inbox", CTRL+Key_1);
	keys->insertItem(QString("Calendar"), "Calendar", CTRL+Key_2);
	keys->insertItem(QString("Contacts"), "Contacts", CTRL+Key_3);
	keys->insertItem(QString("Tasks"), "Tasks", CTRL+Key_4);
	keys->insertItem(QString("Journal"), "Journal", CTRL+Key_5);
	keys->insertItem(QString("Notes"), "Notes", CTRL+Key_6);
	keys->insertItem(QString("DeletedItems"), "DeletedItems", CTRL+Key_7);
	keys->connectItem("AboutApp", this, SLOT(slotAbout()));
	keys->connectItem("Disconnect", this, SLOT(slotDisconnect()));
	keys->connectItem("Inbox", this, SLOT(slotKoInbox()));
	keys->connectItem("Calendar", this, SLOT(slotKoCalendar()));
	keys->connectItem("Contacts", this, SLOT(slotKoContacts()));
	keys->connectItem("Refresh", this, SLOT(slotRefreshVisiblePane()));
	keys->connectItem("Tasks", this, SLOT(slotKoTasks()));
	keys->connectItem("Journal", this, SLOT(slotKoJournal()));
	keys->connectItem("Notes", this, SLOT(slotKoNotes()));
	keys->connectItem("DeletedItems", this, SLOT(slotKoDeleted()));
	keys->readSettings();

	/**
	 ** New "whatever" Button
	 **/
	m_tb_new = new QPopupMenu(this);
	m_tb_new->insertItem(SmallIcon(QString("kword")), QString("New &Message"), this, SLOT(slotNewMessage()));
	m_tb_new->insertItem(SmallIcon(QString("knotes")), QString("New &Note"), this, SLOT(slotNewNote()));
	m_tb_new->insertItem(SmallIcon(QString("klipper")), QString("New &Task"), this, SLOT(slotNewTask()));

	i = toolBar("main")->insertButton(SmallIcon(QString("kword")), ID_NEW, true, QString("New Message"), -1);
	toolBar("main")->setDelayedPopup(i, m_tb_new);
	tb_NewButtonId = i;

	toolBar("main")->insertButton(
		QString("next"), 
		ID_NEXT, 
		true, 
		QString("Goto next folder w/ unread messages"), 
		-1, 
		KGlobal::instance()
	);

	toolBar("main")->insertLineSeparator();
	i = toolBar("main")->insertButton(
		QString("fileprint"), 
		ID_REFRESH, 
		true, 
		QString("Print message"), 
		-1, 
		KGlobal::instance()
	);
	toolBar("main")->setItemEnabled(i,false);
	toolBar("main")->insertButton(
		QString("reload"), 
		ID_REFRESH, 
		true, 
		QString("Refresh message list"), 
		-1, 
		KGlobal::instance()
	);

	toolBar("main")->insertLineSeparator();
	toolBar("main")->insertButton(
		QString("queue"), 
		ID_BUDDYLIST, 
		true, 
		QString("View Buddylist"), 
		-1, 
		KGlobal::instance()
	);

	toolBar("main")->insertLineSeparator();
	i = toolBar("main")->insertButton(
		QString("mail_reply"), 
		ID_BUDDYLIST, 
		true, 
		QString("Reply"), 
		-1, 
		KGlobal::instance());
	toolBar("main")->setItemEnabled(i,false);
	i = toolBar("main")->insertButton(
		QString("mail_replyall"), 
		ID_BUDDYLIST, 
		true, 
		QString("Reply to All"), 
		-1, 
		KGlobal::instance());
	toolBar("main")->setItemEnabled(i,false);
	i = toolBar("main")->insertButton(
		QString("mail_forward"), 
		ID_BUDDYLIST, 
		true, 
		QString("Reply to All"), 
		-1, 
		KGlobal::instance());
	toolBar("main")->setItemEnabled(i,false);

	emit slotUpdateToolbar();
	toolBar("main")->setFullSize( false );
	connect(toolBar("main"), SIGNAL(clicked(int)), this, SLOT(processTbEvent(int)));

	statusBar()->insertItem(QString("Infusion ")+QString(VERSION),0,0,true);
	statusBar()->insertItem(QString("Offline"),1,0,true);
	statusBar()->insertItem(QString("Welcome to Infusion!"),2,1,true);
	statusBar()->setItemAlignment(2, AlignVCenter);

	QHBox *hbox = new QHBox(this);
	hbox->setSpacing(3);
	hbox->setMargin(3);

	/**
	 ** This section of code is linked in OPTIONALLY.  It 
	 ** adds a Microsoft Outlook-ish toolbar to the left 
	 ** pane of your Infusion window, but requires a ton 
	 ** of additional libraries (the KOffice-related ones, 
	 ** in particular).  Some users may wish to _not_ use 
	 ** this feature, since it requires libraries which 
	 ** are not traditionally a part of the base KDE 
	 ** distribution.  Et tu, Brute'?
	 **/
#ifdef	HAVE_KOOLBAR

	/**
	 ** Create the KoolBar
	 **/
	i_kbContainer = new QVBox(hbox);
	i_kbContainer->setFrameShape(QFrame::WinPanel);
	i_kbContainer->setFrameShadow(QFrame::Sunken);

	i_koolBar = new KoKoolBar(i_kbContainer);
	i_kbContainer->setFixedWidth(80);

	/**
	 ** Add standard KoolBar group.
	 **/
	i_koolBar->insertGroup(QString("Infusion"));

	/**
	 ** Add standard widgets to group.
	i_koolBar->insertItem(0, DesktopIcon("kword",32), 
		QString("Inbox"), this, SLOT(slotKoolBar(int,int)));
	i_koolBar->insertItem(0, DesktopIcon("karm",32), 
		QString("Calendar"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("ktalkd",32), 
		QString("Contacts"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("klipper",32), 
		QString("Tasks"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("korganizer",32), 
		QString("Journal"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("knotes",32), 
		QString("Notes"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("trashcan_empty",32), 
		QString("Deleted Items"), this, SLOT(slotKoolBar(int, int)));
	 **/

	i_koolBar->insertGroup(QString("Bookmarks"));
#endif

	QVBox *vbox = new QVBox(hbox);
	vbox->setSpacing(3);

	i_titleBar = new CxObjTitleBar(vbox);
	connect(i_titleBar, SIGNAL(title_clicked()), this, SLOT(slotToggleRooms()));
	emit i_titleBar->slotUpdate(QString("Infusion"), DesktopIcon(QString("mail_generic"),32));

	Shoriz = new QSplitter(QSplitter::Horizontal, vbox);
	Shoriz->setOpaqueResize( true );

	/**
	 ** Set up the rooms ("folders") list.
	 **/
	i_folderList = new CxObjFolderList(Shoriz,0,QString::null,"wndMain.objFolderlist");
	Shoriz->setResizeMode(i_folderList, QSplitter::KeepSize);
	i_folderList->setMinimumSize( 0, 0 );

	i_widgetStack = new QWidgetStack( Shoriz );
	i_widgetStack->setMinimumSize( 0, 0 );

	setCentralWidget(hbox);

	currentView = CxWndMain::OtherView;

	/**
	 ** MENU: "File"
	 **/
	m_file = new QPopupMenu();
	QPopupMenu *m_file_new = new QPopupMenu();

	/**
	 ** MENU: "File"->"New..."
	 **/
	m_file_new->insertItem(SmallIcon(QString("kword")), QString("&Mail Message"), this, SLOT(slotNewMessage()));
	m_file_new->insertItem(SmallIcon(QString("knotes")), QString("&Note"), this, SLOT(slotNewMessage()));
	m_file_new->insertItem(SmallIcon(QString("klipper")), QString("&Task"), this, SLOT(slotNewTask()));

	m_file->insertItem(SmallIcon(QString("filenew")), QString("&New..."), m_file_new);
	m_file->insertSeparator();
	i = m_file->insertItem(SmallIcon(QString("connect_no")), QString("&Disconnect"), this, SLOT(slotDisconnect()));
	keys->changeMenuAccel(m_file, i, "Disconnect");
	i = m_file->insertItem(SmallIcon(QString("exit")), QString("E&xit"), this, SLOT(slotExit()));
	keys->changeMenuAccel(m_file, i, KStdAccel::Quit);

	/**
	 ** MENU: "Edit"
	 **/

	/**
	 ** MENU: "Go"
	 **/
	m_go = new QPopupMenu();

	for(int x=0; x<100; x++) {
		i_goPos.append( QString::null );
#ifdef	HAVE_KOOLBAR
		i_kbPos.append( QString::null );
#endif
	}

	LoadComponent( CXINBOX, i_widgetStack, SLOT(slotKoInbox()), new CxObjFolderView( i_widgetStack ) );
	LoadComponent( "libkorganizer", "Calendar", "korganizer", i_widgetStack );
	LoadComponent( CXCONTACTS, i_widgetStack, SLOT(slotKoContacts()), new CxObjAddrBookView( i_widgetStack ) );
	LoadComponent( CXNOTES, i_widgetStack, SLOT(slotKoNotes()), new CxObjNotesView( i_widgetStack ) );
	LoadComponent( CXTASKS, i_widgetStack, SLOT(slotKoTasks()), new CxObjTasksView( i_widgetStack ) );
	LoadComponent( CXTRASH, i_widgetStack, SLOT(slotKoDeleted()), 
		new CxObjFolderView( i_widgetStack, QString("Trashcan") ) );

	/**
	 ** MENU: "View"->"Toolbar"
	 **/
	//m_view_toolbar = new QPopupMenu();

	/**
	 ** MENU: "View"
	 **/
	m_view = new QPopupMenu();
	m_view->setCheckable(true);

	m_id_view_folderlist = m_view->insertItem(i18n("Show &Folder List"), this, SLOT(slotToggleRooms()));
	m_view->setItemChecked(m_id_view_folderlist,i_folderList->isVisible()?true:false);

	if(i_genericViews["cxobjfolderview"]) {
		m_id_view_mesgpane = m_view->insertItem(i18n("Show &Message Pane"), this, SLOT(slotToggleMessagePane()));
		m_view->setItemChecked(m_id_view_mesgpane, 
			((CxObjFolderView*)i_genericViews["cxobjfolderview"])->isPaneVisible()?true:false);

		m_id_view_mesghdr = m_view->insertItem(i18n("Show Message &Header"), this, SLOT(slotToggleMessageHdr()));
		m_view->setItemChecked(m_id_view_mesghdr, 
			((CxObjFolderView*)i_genericViews["cxobjfolderview"])->isHdrVisible()?true:false);
	}

	m_id_view_statusbar = m_view->insertItem(i18n("Show &Status Bar"), this, SLOT(slotToggleStatusBar()));
	m_view->setItemChecked(m_id_view_statusbar,statusBar()->isVisible()?true:false);

	m_id_view_titlebar = m_view->insertItem(i18n("Show &Title Bar"), this, SLOT(slotToggleTitleBar()));
	m_view->setItemChecked(m_id_view_titlebar, i_titleBar->isVisible()?true:false);

#ifdef	HAVE_KOOLBAR
	m_id_view_infusionbar = m_view->insertItem(i18n("Show &Infusion Bar"), this, SLOT(slotToggleKoolBar()));
//	m_view->setItemChecked( m_id_view_infusionbar, i_kbContainer->isVisible()?true,false );
	m_view->setItemChecked( m_id_view_infusionbar, true );
#endif

	m_view->insertItem(i18n("Show &Toolbar"), this, SLOT(slotToggleToolbar()));

//	i = m_view->insertItem(SmallIcon(QString("reload")), QString("Check messages..."), i_folderPane, SLOT(refresh()));
//	keys->changeMenuAccel(m_view, i, "Refresh");
//	m_view->insertSeparator();

	/**
	 ** MENU: "Compose"
	 **/
	m_compose = new QPopupMenu();
	m_compose->insertItem(SmallIcon(i18n("filenew")), i18n("&New Mail Message"), this, SLOT(slotNewEmail()));
	m_compose->insertItem( i18n("New Po&st in This Folder"), this, SLOT(slotNewPost()));
	m_compose->insertItem( i18n("C&hoose Template..."), NULL);
	m_compose->insertItem( i18n("Ch&oose Form..."), NULL);
	m_compose->insertSeparator();
	m_compose->insertItem(SmallIcon(QString("mail_reply")), i18n("&Reply"), NULL);
	m_compose->insertItem(SmallIcon(QString("mail_replyall")), i18n("Reply to A&ll"), NULL);
	m_compose->insertItem(SmallIcon(QString("mail_forward")), i18n("For&ward"), NULL);

	m_help = new KHelpMenu(this, QString::null);
	connect( m_help, SIGNAL(showAboutApplication()), this, SLOT(slotAbout()));

	i_menu = new KMenuBar(this);
	i_menu->insertItem("&File", m_file);
	i_menu->insertItem("&View", m_view);
	i_menu->insertItem("&Go", m_go);
	i_menu->insertItem("&Compose", m_compose);
	i_menu->insertSeparator();
	i_menu->insertItem("&Help", m_help->menu());

	/**
	 ** Set up popup menus.
	 **/
	m_popUp_noItem = new QPopupMenu();
	m_popUp_noItem->insertItem("&New Mail Message...", this, SLOT(slotNewMessage()));

	m_popUp_item = new QPopupMenu();
	m_popUp_noItem->insertItem("&Open", this, SLOT(slotNewMessage()));

	resize(600, 400);

	KConfig * config = KGlobal::config();
	config->setGroup("WM");
	applyMainWindowSettings(config);
	readProperties(config);

	/**
	 ** Signal DCOP to start the Infusion Daemon.
	 **/
	slotStartDaemon();
}

/**
 ** CxWndMain::setStatusMsg(): Set the statusbar message.
 **/
void		CxWndMain::setStatusMsg(const QString& s) {

	statusBar()->changeItem(s,2);
}

/**
 ** CxWndMain::isConnected(): Are we online?
 **/
int		CxWndMain::isConnected() {

	return(Connected);
}

/**
 ** CxWndMain::setConnected(): Set whether or not we are online.
 **/
void		CxWndMain::setConnected(int i) {

	Connected = i;

	if(i) {
		statusBar()->clear();
		statusBar()->changeItem(QString("Online"),1);
	} else {
		statusBar()->clear();
		statusBar()->changeItem(QString("Offline"),1);
	}
}

/**
 ** CxWndMain::closeEvent(): What do we do when we exit?
 **/
void 		CxWndMain::closeEvent(QCloseEvent *) {

	KConfig *config = KGlobal::config();
	saveProperties(config);
	config->setGroup("WM");
	saveMainWindowSettings(config);
	config->sync();

	_RoomIndex = CxLlFlush(_RoomIndex);
	_FloorIndex = CxLlFlush(_FloorIndex);

	if(isConnected()) {
		CxClSend(g_cxHndl, "QUIT");
		CxClDisconnect( g_cxHndl );
		CxClDelete( g_cxHndl );
	}
	kapp->quit();
}

/**
 ** CxWndMain::slotChat(): Launch a new chat window.
 **/
void		CxWndMain::slotChat() {
	
        if (!dcop->send("infusiond","CxMessenger","buddyList()","")) {
		cerr << "Infusion::slotChat(): DCOP communications may be broken!" << endl;
		KMessageBox::sorry( this,
			QString("I was unable to contact the Infusion Daemon!\nPerhaps it has crashed?"),
			QString("Failed!"),
			false
		);
        }
}

/**
 ** CxWndMain::slotNewMessage(): Launch a new Message Composer.
 **/
void		CxWndMain::slotNewMessage() {

/**	if((QString(Room) == "Mail") || (CxMsSaveOk(g_cxHndl, User.ascii()))) { **/
		CxWndMesg *msg = new CxWndMesg(QString::null, QString::null, QString::null, QString(Room), QString::null, QDateTime::currentDateTime(), true);
		msg->show();
/**	} else {
		KMessageBox::sorry(this,
			QString("You do not have permission to post messages in this room!"),
			QString("Permission Denied!"),
			false
		);
	} **/
}

/**
 ** CxWndMain::slotNewNote(): Launch a new Note window.
 **/
void		CxWndMain::slotNewNote() {

	CxWndNote *note = new CxWndNote(NULL, QString::null);
	note->show();
}

/**
 ** CxWndMain::slotNewTask(): Launch a new Task Composer.
 **/
void		CxWndMain::slotNewTask() {

	CxWndTask *msg = new CxWndTask(1);
	msg->show();
}

/**
 ** CxWndMain::slotDisconnect(): Time to log off...
 **/
void		CxWndMain::slotDisconnect() {
int		i = 0;

	if(isConnected()) {
	
		i = KMessageBox::questionYesNo(this, 
				QString("Are you sure you wish to disconnect from ")+
				QString("localhost")+
				QString("?"),
				QString("Disconnect from Server?"),
				QString("Yes"),
				QString("No"),
				false
			);
	}

	/**
	 ** We got 'Yes' back.
	 **/
	if((i==3) || (isConnected())) {

		emit i_titleBar->slotUpdate(QString("Infusion"), DesktopIcon(QString("mail_generic"),32));

		if(isConnected()) {

			if(_RoomIndex) _RoomIndex = CxLlFlush(_RoomIndex);
			if(_FloorIndex) _FloorIndex = CxLlFlush(_FloorIndex);
			emit i_folderList->clear();

			QDictIterator<CxObjGenericView> qdi( i_genericViews );
			while ( qdi.current() ) {
				kdDebug() << "CxWndMain::disconnect(): " << qdi.currentKey() << "->clear()" << endl;
				emit (qdi.current())->clear();
				++qdi;
			}

			CxClSend(g_cxHndl, "QUIT");
			CxClDisconnect( g_cxHndl );
			CxClDelete( g_cxHndl );
			setConnected(0);

			dcop->send("infusiond","CxMessenger","goOffline()","");
		}

		CxWndLogin *wndLogin = new CxWndLogin(g_InfusionApp, QString("Hello"));
		wndLogin->show();
	}
}

/**
 ** CxWndMain::slotNext(): Goto next room w/ unread messages.
 **/
void		CxWndMain::slotNext() {
ROOMINFO	*ri;

	if((ri = CxRmGoto(g_cxHndl, NULL,0))) {
		strcpy(Room, ri->name);
		free(ri);

		if( i_genericViews["cxobjfolderview"] ) {
			emit i_genericViews["cxobjfolderview"]->refresh();
		}
	}
}

/**
 ** CxWndMain::slotExit(): I'm outta here!
 **/
void		CxWndMain::slotExit() {

	close();
}

/**
 ** CxWndMain::processTbEvent(): Process a toolbar event
 **/
void		CxWndMain::processTbEvent(int id) {

	switch(id) {
		case(ID_NEW):
			emit slotNewMessage();
			break;

		case(ID_NEXT):
			emit slotNext();
			break;

		case(ID_REFRESH):
			emit slotRefreshVisiblePane();
			break;

		case(ID_BUDDYLIST):
			emit slotChat();
			break;

		default:
			break;
	}
}

/**
 ** CxWndMain::itemSelected(): What happens when we select an item?
 **/
void		CxWndMain::itemSelected(QListViewItem *item) {

	if(!item) return;

	if(!item->childCount()) {
		emit gotoRoom(item->text(0));
	}
	return;
}

/**
 ** CxWndMain::gotoRoom(): What happens when we select an item?
 **/
void		CxWndMain::gotoRoom(QString text) {
ROOMINFO	*ri = 0L;
char		ss[200];


	strcpy(ss, text.ascii());
	if(!strcmp(ss,"Mail Inbox")) {
		currentView = CxWndMain::InboxView;
		strcpy(ss, "_MAIL_");
	} else if(!strcmp(ss,"Mail")) {
		currentView = CxWndMain::InboxView;
		strcpy(ss, "_MAIL_");
	} else {
		currentView = CxWndMain::OtherView;
	}

	if((ri = CxRmGoto(g_cxHndl,ss,0))) {
		strcpy(Room, ri->name);
		//emit i_titleBar->slotUpdate( QString(Room), QPixmap( folder_32x32_xpm ));
		if(i_genericViews["cxobjfolderview"]) emit ((CxObjFolderView*)i_genericViews["cxobjfolderview"])->gotoRoom( QString(Room) );
		free(ri);
	}
}

/**
 ** CxWndMain::slotUpdateLstFolders(): Keep the folder list in sync with anything else that's
 ** going on.
 **/
void		CxWndMain::slotUpdateLstFloors(const QString &rm) {
QListViewItem	*i, *ii;

	if(!isConnected()) return;

	i=i_folderList->firstChild();
	while( i->nextSibling() ) {
		i->setSelected(false);
		i = i->nextSibling();
	}

	ii = i->firstChild();
	if( ii ) {
		while( ii ) {
			if(ii->text(0) == rm) ii->setSelected(true);
			else ii->setSelected(false);
			ii = ii->nextSibling();
		}
	}
}

/**
 ** CxWndMain::slotUpdateToolbar(): Adjust the toolbar to represent
 ** our current View.
 **/
void		CxWndMain::slotUpdateToolbar() {

	/**
	 ** The rest of the buttons will change, depending on
	 ** the current view.
	 **/
	switch(currentView) {
		case(InboxView):
		case(OtherView): 
			break;

		case(CalendarView):
//			i_calendarPane->CxToolbar()->show();
			break;
		case(ContactsView):
			break;
		case(TasksView):
			break;
		case(JournalView):
			break;
		case(NotesView):
			break;
		case(TrashView):
			break;
	}

	toolBar("main")->show();
}

/**
 ** CxWndMain::slotKoInbox(): Jump to inbox.
 **/
void		CxWndMain::slotKoInbox() {

	if(i_genericViews["cxobjfolderview"]) {
//		if(isConnected()) {
//			gotoRoom("_MAIL_");
//			emit i_genericViews["cxobjfolderview"]->refresh();
//		}

		currentView = CxWndMain::InboxView;
		emit i_titleBar->slotUpdate(QString("Inbox"), DesktopIcon(QString("kword"),32));
		emit slotUpdateLstFloors(QString("Inbox"));
		toolBar("main")->getButton(tb_NewButtonId)->setDefaultIcon(QString("kword"));
		emit slotUpdateToolbar();
		i_widgetStack->raiseWidget( i_genericViews["cxobjfolderview"] );
	}
}

/**
 ** CxWndMain::slotKoCalendar(): Jump to contacts view.
 **/
void		CxWndMain::slotKoCalendar() {

	currentView = CxWndMain::CalendarView;

	CxObjGenericView *cview = i_genericViews["libkorganizer"];
	if( cview ) {
		emit i_titleBar->slotUpdate(cview->CxObjectName(), cview->CxDesktopIcon());
		emit slotUpdateLstFloors(QString("Calendar"));
		emit slotUpdateToolbar();

		i_widgetStack->raiseWidget( cview );
	}
}

/**
 ** CxWndMain::slotKoContacts(): Jump to contacts view.
 **/
void		CxWndMain::slotKoContacts() {

	currentView = CxWndMain::ContactsView;

	CxObjGenericView *cview = i_genericViews["cxobjaddrbookview"];
	if( cview ) {
		emit i_titleBar->slotUpdate(cview->CxObjectName(), cview->CxDesktopIcon());
		emit slotUpdateLstFloors(QString("Contacts"));
		toolBar("main")->getButton(tb_NewButtonId)->setDefaultIcon(QString("ktalkd"));
		emit slotUpdateToolbar();

		i_widgetStack->raiseWidget( cview );
	}
}

/**
 ** CxWndMain::slotKoNotes(): Jump to notes view.
 **/
void		CxWndMain::slotKoNotes() {

	if(i_genericViews["cxobjnotesview"]) {
		currentView = CxWndMain::NotesView;
		if(isConnected()) {
			emit slotUpdateLstFloors(QString("Notes"));
		}

		emit i_titleBar->slotUpdate(i_genericViews["cxobjnotesview"]->CxObjectName(), i_genericViews["cxobjnotesview"]->CxDesktopIcon());
		emit slotUpdateLstFloors(QString("Notes"));
		toolBar("main")->getButton(tb_NewButtonId)->setDefaultIcon(QString("knotes"));
		emit slotUpdateToolbar();

		i_widgetStack->raiseWidget( i_genericViews["cxobjnotesview"] );
	}
}

/**
 ** CxWndMain::slotKoTasks(): Jump to tasks view.
 **/
void		CxWndMain::slotKoTasks() {

	if(i_genericViews["cxobjtasksview"]) {
		currentView = CxWndMain::TasksView;
		emit i_titleBar->slotUpdate(QString("Tasks"), DesktopIcon(QString("klipper"),32));
		emit slotUpdateLstFloors(QString("Tasks"));

		toolBar("main")->getButton(tb_NewButtonId)->setDefaultIcon(QString("klipper"));
		emit slotUpdateToolbar();

		i_widgetStack->raiseWidget( i_genericViews["cxobjtasksview"] );
	}
}

/**
 ** CxWndMain::slotKoJournal(): Jump to journal view.
 **/
void		CxWndMain::slotKoJournal() {

	currentView = CxWndMain::JournalView;
	emit slotUpdateLstFloors(QString("Journal"));
	emit slotUpdateToolbar();
}

/**
 ** CxWndMain::slotKoDeleted(): Jump to deleted items view.
 **/
void		CxWndMain::slotKoDeleted() {


	if(i_genericViews["cxobjtrashview"]) {
		currentView = CxWndMain::TrashView;
		emit slotUpdateLstFloors(QString("Deleted Items"));
		emit slotUpdateToolbar();

		i_widgetStack->raiseWidget( i_genericViews["cxobjtrashview"] );
	}
}

/**
 ** CxWndMain::slotKoByName(): Raise an object BY NAME.
 **/
void		CxWndMain::slotKoByName( const QString &name ) {

	kdDebug() << "CxWndMain::slotKoByName(): name: " << name << endl;

	if(name.isNull()) return;
	i_widgetStack->raiseWidget( i_genericViews[name] );
}

/**
 ** CxWndMain::slotKoExternal(): Raise an EXTERNAL/EMBEDDED
 ** object.
 **/
void		CxWndMain::slotKoExternal( int grp, int obj ) {

	kdDebug() << "CxWndMain::slotKoExternal(): grp: " << grp << endl;
	kdDebug() << "CxWndMain::slotKoExternal(): obj: " << obj << endl;
	if( (grp != 0) || (obj<0) ) return;

#ifdef	HAVE_KOOLBAR
	emit slotKoByName( i_kbPos[ obj ] );
#endif
}

/**
 ** CxWndMain::slotKoExternal(): This was generated by a MENU, not a KOOLBAR.
 **/
void		CxWndMain::slotKoExternal( int obj ) {

	kdDebug() << "CxWndMain::slotKoExternal(): obj: " << abs(obj) << endl;
	emit slotKoByName( i_goPos[ abs(obj) ] );
}

/**
 ** CxWndMain::slotToggleTitleBar(): Titlebar callback.
 **/
void		CxWndMain::slotToggleTitleBar() {

	if(i_titleBar->isVisible()) i_titleBar->hide();
	else i_titleBar->show();

	m_view->setItemChecked(m_id_view_titlebar, i_titleBar->isVisible()?true:false);
}

/**
 ** CxWndMain::slotToggleKoolBar(): koolbar callback.
 **/
void		CxWndMain::slotToggleKoolBar() {

#ifdef		HAVE_KOOLBAR
	if(i_kbContainer->isVisible()) i_kbContainer->hide();
	else i_kbContainer->show();
	
	m_view->setItemChecked(m_id_view_infusionbar, i_kbContainer->isVisible()?true:false);
#endif
}

/**
 ** CxWndMain::slotKoolBar(): koolbar callback.
 **/
void		CxWndMain::slotKoolBar(int group, int item) {

	switch(group) {
		case(0):
		switch(item) {
			case(1):			// INBOX
				emit slotKoInbox();
				break;
			case(2):			// CALENDAR
				emit slotKoCalendar();
				break;
			case(3):			// CONTACTS
				emit slotKoContacts();
				break;
			case(4):			// TASKS	
				emit slotKoTasks();
				break;
			case(6):			// NOTES
				emit slotKoNotes();
				break;
		} break;
	}
}

/**
 ** CxWndMain::slotToggleMessagePane(): Toggle message pane.
 **/
void		CxWndMain::slotToggleMessagePane() {

	if(i_genericViews["cxobjfolderview"]) {
		emit ((CxObjFolderView*)i_genericViews["cxobjfolderview"])->slotTogglePane();
		m_view->setItemChecked(m_id_view_mesgpane, ((CxObjFolderView*)i_genericViews["cxobjfolderview"])->isPaneVisible()?true:false);
	}
}

/**
 ** CxWndMain::slotToggleMessageHdr(): Toggle message pane.
 **/
void		CxWndMain::slotToggleMessageHdr() {

	CxObjFolderView *cview = (CxObjFolderView *)i_genericViews["cxobjfolderview"];
	if(cview) {
		emit cview->slotToggleHdr();
		m_view->setItemChecked(m_id_view_mesghdr, cview->isHdrVisible()?true:false);
	}
}

/**
 ** CxWndMain::slotToggleRooms(): Toggle rooms list.
 **/
void		CxWndMain::slotToggleRooms() {

	if(i_folderList->isVisible()) i_folderList->hide();
	else i_folderList->show();
	m_view->setItemChecked(m_id_view_folderlist, !m_view->isItemChecked(m_id_view_folderlist));
}

/**
 ** CxWndMain::slotToggleToolbar(): Toggle tool bar.
 **/
void		CxWndMain::slotToggleToolbar() {

	if(toolBar("main")->isVisible()) toolBar("main")->hide();
	else toolBar("main")->show();
}

/**
 ** CxWndMain::slotToggleStatusBar(): Toggle status bar.
 **/
void		CxWndMain::slotToggleStatusBar() {

	if(statusBar()->isVisible()) statusBar()->hide();
	else statusBar()->show();
	m_view->setItemChecked(m_id_view_statusbar, !m_view->isItemChecked(m_id_view_statusbar));
}

/**
 ** CxWndMain::initializeClient(): Startup stuff.
 **/
void		CxWndMain::initializeClient() {
QCString	replyType;
QByteArray	replyData;

	kdDebug() << "CxWndMain::initializeClient(): entered" << endl;
	kapp->setOverrideCursor(waitCursor);

	/**
	 ** Obtain the logged-in username from the daemon.
	 **/
        if (!dcop->call("infusiond","CxMessenger","accountName()", 0L, replyType, replyData)) {
		cerr << "Infusion CxWndMain::initializeClient(): DCOP communications may be broken!" << endl;
	} else {
		QDataStream reply( replyData, IO_ReadOnly );
		if( replyType == "QString" ) {
			QString result;
			reply >> result;
			kdDebug() << "CxWndMain::initializeClient(): daemon response acceptable" << endl;
		} else {
			cerr << "Infusion CxWndMain::initializeClient(): Your daemon is unzipped." << endl;
		}
	}

	kdDebug() << "CxWndMain::initializeClient(): Populating user interface..." << endl;
	kdDebug() << "CxWndMain::initializeClient(): i_folderList->refresh()" << endl;
	emit i_folderList->refresh();

	QDictIterator<CxObjGenericView> qdi( i_genericViews );
        while ( qdi.current() ) {
		kdDebug() << "CxWndMain::initializeClient(): " << qdi.currentKey() << "->refresh()" << endl;
		emit (qdi.current())->refresh();
		++qdi;
        }
	kdDebug() << "CxWndMain::initializeClient(): Done!" << endl;

	emit wndAction->updateStatus(100, "Welcome to Infusion!");

	QTimer *mytimer = new QTimer(this, "wndMain.tickTock.bewmAction");
	mytimer->singleShot(1000, wndAction, SLOT(close()));

	kapp->restoreOverrideCursor();
	kdDebug() << "CxWndMain::initializeClient(): execution completed" << endl;
}

/**
 ** CxWndMain::slotAbout(): About Us.
 **/
void		CxWndMain::slotAbout() {

	CxWndAbout *about = new CxWndAbout(NULL, QString("About Infusion"));
	about->show();
}

/**
 ** CxWndMain::saveProperties(): ...
 **/
void		CxWndMain::saveProperties(KConfig *config) {
QString		view("View");

	config->setGroup(QString("General"));

	/**
	 ** Inbox
	 **/
	if(currentView==InboxView) {
		config->writeEntry(view, QString("InboxView") );

	} else if(currentView==CalendarView) {
		config->writeEntry(view, QString("CalendarView") );

	} else if(currentView==ContactsView) {
		config->writeEntry(view, QString("ContactsView") );

	} else if(currentView==TasksView) {
		config->writeEntry(view, QString("TasksView") );

	} else if(currentView==NotesView) {
		config->writeEntry(view, QString("NotesView") );

	} else if(currentView==JournalView) {
		config->writeEntry(view, QString("JournalView") );

	} else {
		config->writeEntry(view, QString("OtherView:")+QString(Room) );
	}

	if(i_genericViews["cxobjfolderview"]) {
		view = QString("FolderListVisible");
		if(i_genericViews["cxobjfolderview"]->isVisible()) config->writeEntry(view, QString("On") );
		else config->writeEntry(view, QString("Off") );

		view = QString("MessagePaneVisible");
		if(((CxObjFolderView*)i_genericViews["cxobjfolderview"])->isPaneVisible()) config->writeEntry(view, QString("On") );
		else config->writeEntry(view, QString("Off") );

		view = QString("Svert.Sizes");
		config->writeEntry( view, ((CxObjFolderView*)i_genericViews["cxobjfolderview"])->sizes()  );
	}

	view = QString("StatusBarVisible");
	if(statusBar()->isVisible()) config->writeEntry(view, QString("On") );
	else config->writeEntry(view, QString("Off") );


	view = QString("TitleBarVisible");
	if(i_titleBar->isVisible()) config->writeEntry(view, QString("On") );
	else config->writeEntry(view, QString("Off") );

#ifdef		HAVE_KOOLBAR
	view = QString("InfusionBarVisible");
	if(i_kbContainer->isVisible()) config->writeEntry(view, QString("On") );
	else config->writeEntry(view, QString("Off") );
#endif

	view = QString("Shoriz.Sizes");
	config->writeEntry( view, Shoriz->sizes()  );

	config->sync();
}

/**
 ** CxWndMain::readProperties(): ...
 **/
void		CxWndMain::readProperties(KConfig *config) {
QString		key("View");
QString		value;

	config->setGroup(QString("General"));

	value = config->readEntry( key, "InboxView");

	kdDebug() << "CxWndMain::readProperties(): Value: " << value << endl;
	/**
	 ** Inbox view active.
	 **/
	if(value == "InboxView") {
		emit slotKoInbox();

	/**
	 ** Calendar view active.
	 **/
	} else if(value == "CalendarView") {
		emit slotKoCalendar();

	/**
	 ** Contacts view active.
	 **/
	} else if(value == "ContactsView") {
		emit slotKoContacts();

	/**
	 ** Tasks view active.
	 **/
	} else if(value == "TasksView") {
		emit slotKoTasks();

	/**
	 ** Journal view active.
	 **/
	} else if(value == "JournalView") {
		emit slotKoJournal();

	/**
	 ** Notes view active.
	 **/
	} else if(value == "NotesView") {
		emit slotKoNotes();

	/**
	 ** User had his mind in the dirt when he exited.
	 **/
	} else if(value == "TrashView") {
		emit slotKoDeleted();

	/**
	 ** User was in a folder when they exited.
	 **/
	} else {
		emit slotKoInbox();
	}

	/**
	 ** Was the FolderList visible?
	 **/
	key = QString("FolderListVisible");
	value = config->readEntry(key, "On");
	if(value != "On") {
		m_view->setItemChecked(m_id_view_folderlist, false);
		if( i_genericViews["cxobjfolderview"] ) i_genericViews["cxobjfolderview"]->hide();
//		i_folderList->hide();
	} else {
		m_view->setItemChecked(m_id_view_folderlist, true);
	}

	key = QString("StatusBarVisible");
	value = config->readEntry(key, "On");
	if(value != "On") {
		m_view->setItemChecked(m_id_view_statusbar, false);
		statusBar()->hide();
	} else {
		m_view->setItemChecked(m_id_view_statusbar, true);
	}

	key = QString("MessagePaneVisible");
	value = config->readEntry(key, "On");
	if(value != "On") {
		m_view->setItemChecked(m_id_view_mesgpane, false);
		emit slotToggleMessagePane();
	} else {
		m_view->setItemChecked(m_id_view_mesgpane, true);
	}

	key = QString("TitleBarVisible");
	value = config->readEntry(key, "On");
	if(value != "On") {
		m_view->setItemChecked(m_id_view_titlebar, false);
		i_titleBar->hide();
	} else {
		m_view->setItemChecked(m_id_view_titlebar, true);
	}

#ifdef		HAVE_KOOLBAR
	key = QString("InfusionBarVisible");
	value = config->readEntry(key, "On");
	if(value != "On")
		i_kbContainer->hide();
#endif

	key = QString("Shoriz.Sizes");
	Shoriz->setSizes(config->readIntListEntry( key ));

	if(i_genericViews["cxobjfolderview"]) {
		key = QString("Svert.Sizes");
		((CxObjFolderView*)i_genericViews["cxobjfolderview"])->setSizes(config->readIntListEntry( key ));
	}
}

/**
 ** CxWndMain::slotRefreshVisiblePane(): Determine which item is
 ** currently visible, and refresh ONLY that item.  This will make
 ** view switching much faster.
 **/
void		CxWndMain::slotRefreshVisiblePane() {

	kapp->setOverrideCursor(waitCursor);
	switch(currentView) {
		case(InboxView):
		case(OtherView):
			if(i_genericViews["cxobjfolderview"]) emit i_genericViews["cxobjfolderview"]->refresh();
			break;
		case(CalendarView):
			if(i_genericViews["libkorganizer"]) emit i_genericViews["libkorganizer"]->refresh();
			break;
		case(ContactsView):
			break;
		case(TasksView):
			if(i_genericViews["cxobjtasksview"]) emit i_genericViews["cxobjtasksview"]->refresh();
			break;
		case(JournalView):
			break;
		case(NotesView):
			if(i_genericViews["cxobjnotesview"]) emit i_genericViews["cxobjnotesview"]->refresh();
			break;
		case(TrashView):
			break;
	}
	kapp->restoreOverrideCursor();
}

/**
 ** CxWndMain::slotStartDaemon(): Start the Infusion Daemon.
 **/
void		CxWndMain::slotStartDaemon() {
QCString	replyType;
QByteArray	replyData;

        /**
         ** If the Infusion Daemon is not running, we need to start it here.  It is
         ** a KUniqueApplication, so we shouldn't need to worry about whether or not
         ** it's running.
         **/
        QString execStr = locate("exe","infusiond");
        system(execStr.latin1());
 
        /**
	 ** Ensure that the daemon is up-to-date.
	 **/
        if (!dcop->send("infusiond","CxMessenger","sync()","")) {
		hide();

		KMessageBox::information( 
			this,
			QString("I was unable to start the Infusion Daemon.  This\n")+
				QString("is necessary to run Infusion.  I'm sorry, but I cannot\n")+
				QString("continue.  Please try manually running 'infusiond'."),
			QString("No Infusion Daemon"),
			QString("Ok"), false );
		cerr << "Infusion CxWndMain::slotStartDaemon(): DCOP communications may be broken!" << endl;
		exit(0);
        }
}

/**
 ** CxWndMain::LoadComponent(): Embed an object in our user interface.
 **/
void		CxWndMain::LoadComponent( CXOBJDEF object, QWidget *parent, const char *slot, CxObjGenericView *refObj ) {
int	i;

	if(i_genericViews[object._objname] || !refObj) {
		kdDebug() << "CxWndMain::LoadComponent(): Failing assertions." << endl;
		return;
	}

	kdDebug() << "CxWndMain::LoadComponent(): Received request to embed new BUILTIN component " << object._objname << endl;

	/**
	 ** Annotate that this is a loaded component, to prevent us from loading the
	 ** same component twice.
	 **/
	i_genericViews.insert( object._objname, refObj );

	i = m_go->insertItem( SmallIcon(object._icon), QString(object._uiname), this, slot );
	i_goPos[abs(i)] = object._objname;

#ifdef		HAVE_KOOLBAR
	i = i_koolBar->insertItem(0, DesktopIcon(object._icon,32), QString(object._uiname), this, slot );
	i_kbPos[i] = object._objname;
#endif
}

/**
 ** CxWndMain::LoadComponent(): This is an alternate form for calling LoadComponent() on
 ** a library module.  We will create a CxObjExternalView() object to wrap around this
 ** component.  (this is a specialized version of CxObjGenericView()...)
 **/
void		CxWndMain::LoadComponent( 
			const QString& library_name, 
			const QString& ui_name, 
			const QString& icon, 
			QWidget *parent ) {
int	i;

	if(i_genericViews[library_name]) return;

	kdDebug() << "CxWndMain::LoadComponent(): Received request to embed new EXTERNAL component " << library_name << endl;

	KLibFactory *factory = KLibLoader::self()->factory(library_name);
	if( factory ) {
		CxObjExternalView *externalView = new CxObjExternalView( parent, library_name );
		externalView->embed( factory );
		externalView->setMinimumWidth( 0 );
		externalView->setMinimumHeight( 0 );

		i_genericViews.insert( library_name, externalView );

		i = m_go->insertItem(SmallIcon(icon), QString(ui_name), this, SLOT(slotKoExternal(int)));
		i_goPos[abs(i)] = library_name;
		//keys->changeMenuAccel(go, i, "Inbox");

#ifdef		HAVE_KOOLBAR
		i = i_koolBar->insertItem(0, DesktopIcon(icon,32), QString(ui_name), this, SLOT(slotKoExternal(int,int)));
		i_kbPos[i] = library_name;
#endif
        }

}

/**
 ** CxWndMain::UnloadComponent(): Unload an object from our UI.  This should
 ** be called in the event that loading an object fails.  Or should it?
 **/
void		CxWndMain::UnloadComponent( const QString &object_id ) {
}

/**
 ** This software will support sound events sometime in the near future...
 **
	KNotifyClient::event("Offline");
 **/
