/**
 ** $Id: wndmesg.h,v 1.7 2001/09/08 02:05:35 brian Exp $
 **/
#ifndef		__WNDMESG_H__
#define		__WNDMESG_H__
#include	<kmainwindow.h>
#include	<kmenubar.h>
#include	<ktoolbar.h>
#include	<kaccel.h>
#include	<qdatetime.h>
#include	<qstring.h>
#include	<qlayout.h>
#include	<qmultilineedit.h>
#include	<qvbox.h>

#define		EBADDATA	4
#define		ENODATA		3
#define		EINVALIDTYPE	2
#define		ENODAEMON	1

class		CxWndMesg : public KMainWindow  {

	Q_OBJECT

public:


			/**
			 ** PRIMARY CONSTRUCTOR: Load pre-determined data into window.
			 **/
			CxWndMesg(const QString & = 0L, const QString& = 0L, const QString& = 0L, 
				const QString& = 0L, const QString& = 0L, 
				const QDateTime& = QDateTime::currentDateTime(), bool = 0L);

			/**
			 ** Other ways of calling the PRIMARY constructor...
			inline CxWndMesg(const QString& to, const QString& subj, const QString& room) {
				CxWndMesg(QString::null, to, subj, room, QString::null, QDateTime::currentDateTime(), false);
			};
			inline CxWndMesg(const QString& to, const QString& room = QString("Mail")) {
				CxWndMesg(QString::null, to, QString::null, room, QString::null, QDateTime::currentDateTime(), false);
			};
			inline CxWndMesg(const QString& room = QString("Mail")) {
				CxWndMesg(QString::null, QString::null, QString::null, room, QString::null, QDateTime::currentDateTime(), false);
			}
			 **/

			/**
			 ** ALTERNATE CONSTRUCTOR: Load by ROOM:MSGID (uses infusiond backend)
			 **/
			CxWndMesg( const QString &, int, bool = false );

inline	bool		errorCode() { return(g_UnableToOpen); };

public slots:
	void		setRcptAddr(const QString&);

private slots:
	void		onSend();
	void		slotChanged();
	void		slotClose();
	void		slotUpdateCaption(const QString &);
	void		processTbEvent(int);
	void		openAddresser();
	void		slotNewEmail();
	void		slotNewPost();

private:
	void		prepareUserInterface();
	void		prepareMenuBar();
	void		prepareComposerPane();
	void		prepareReaderPane();

	/**
	 ** Global Object Data: This data is what was captured
	 ** when we were instantiated.  It will not change at
	 ** any point beyond instantiation, and can be used for
	 ** "reset" and "close-if-unchanged" functionality.
	 **/
	QString		g_Room,
			g_From,
			g_To,
			g_Cc,
			g_Subject,
			g_MessageBody;
	QDateTime	g_DateTime;
	bool		g_ComposerWin;
	uint		g_UnableToOpen;

	/**
	 ** Global User Interface Components: These objects are
	 ** referenced by functions throughout this object, and
	 ** control the behavior of the object.
	 **/
	KLineEdit	*i_lRcpt,
			*i_lCc,
			*i_lSubj;
	QMultiLineEdit	*i_txtBody;
	KStatusBar	*i_status;
	QVBox		*i_page;
	KAccel		*i_keys;

	/**
	 ** Menu Bar: The object's global menubar.
	 **/
	KMenuBar	*m_menu;
	QPopupMenu	*m_file,
			*m_go,
			*m_compose,
			*m_help;

	/**
	 ** Get rid of ive_been_changed...
	 **/
	int		i_am_a_composer,
			ive_been_changed;
};

#endif
