/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: wndnewaccount.o
 ** Date: 2001-01-08
 ** Last Revision: 2001-01-10
 ** Description: New user signup wizard.
 ** CVS: $Id: wndnewaccount.cpp,v 1.8 2001/07/25 02:22:15 brian Exp $
 **/
extern "C" {
#include        <string.h>
};
#include        <qvbox.h>
#include        <qhbox.h>
#include        <qlabel.h>
#include        <qtimer.h>
#include        <kglobal.h>
#include        <klocale.h>
#include        <kdialog.h>
#include        <kiconloader.h>
#include        <kmessagebox.h>
#include        <qstring.h>
#include        <CxClient.h>
#include	"wndnewaccount.h"
#include	"wndlogin.h"
#include	"wndaction.h"
#include	"wndmain.h"
#include	"icons/infusiondlg.xpm"

extern CxWndMain	*wndMain;
extern CxWndAction	*wndAction;

/**
 ** CxWndNewAcct::CxWndNewAcct(): Constructor
 **/
		CxWndNewAcct::CxWndNewAcct() :
			QWizard( NULL ) {

	pageNumber = 0;
	setCaption(i18n("New Account Signup"));
//	connect(btnCancel(), SIGNAL(clicked()), this, SLOT(slotCancel()));

	/**
	 ** Page 1: Explain to the user what's going on.
	 **/
	page1 = new QHBox(this);
	page1->setMargin(KDialog::marginHint());
	page1->setSpacing(KDialog::spacingHint());
	QLabel *pm1 = new QLabel(page1);
	pm1->setPixmap(QPixmap(infusiondlg_xpm));
	QLabel *lb1 = new QLabel(page1);
	lb1->setText(
		i18n("Hello, and welcome to infusion.  This wizard will allow you\n")+
		i18n("to sign up for an account on a Citadel/UX server, so you are\n")+
		i18n("able to start using infusion right now!  If you do not have\n")+
		i18n("an account on a Citadel/UX server, please click on NEXT to sign\n")+
		i18n("up for one now!\n") );
	addPage(page1, i18n("Welcome to infusion!"));
	setBackEnabled(page1, false);
	setNextEnabled(page1, true);

	/**
	 ** Page 2: Allow the user to select a username and
	 ** password.
	 **/
	page2 = new QHBox(this);
	page2->setMargin(KDialog::marginHint());
	page2->setSpacing(KDialog::spacingHint());
	QLabel *pm2 = new QLabel(page2);
	pm2->setPixmap(QPixmap(infusiondlg_xpm));
	QVBox *p2vb1 = new QVBox(page2);
	QLabel *p2lb1 = new QLabel(p2vb1);
	p2lb1->setText(
		i18n("Please select the username and password you wish to use on your\n")+
		i18n("account.") );
	QHBox *p2hb1 = new QHBox(p2vb1);
	p2hb1->setSpacing(KDialog::spacingHint());
	QLabel *p2lb2;
	p2lb2 = new QLabel(i18n("Username:"), p2hb1);
	leUsername = new QLineEdit(p2hb1);
	QHBox *p2hb2 = new QHBox(p2vb1);
	p2hb2->setSpacing(KDialog::spacingHint());
	QLabel *p2lb3;
	p2lb3 = new QLabel(i18n("Password:"), p2hb2);
	lePassword = new QLineEdit(p2hb2);
	addPage(page2, i18n("Account Name Selection"));
	setBackEnabled(page2, true);
	setNextEnabled(page2, true);

	/**
	 ** Page 3: Request more information from the user.
	 **/
	page3 = new QHBox(this);
	page3->setMargin(KDialog::marginHint());
	page3->setSpacing(KDialog::spacingHint());
	QLabel *pm3 = new QLabel(page3);
	pm3->setPixmap(QPixmap(infusiondlg_xpm));

	QVBox *p3vb1 = new QVBox(page3);

	QTextBrowser *p3tb1 = new QTextBrowser(p3vb1);
	p3tb1->setText(
		i18n("TERMS OF SYSTEM USAGE\n\n")+
		i18n("1) ACCOUNT RIGHTS- You are applying for an account on a system which is under the sole\n")+
		i18n("control of its System Administrator.  Therefore, you are permitted to use the account\n")+
		i18n("under that system's Acceptable Use Policy.  Please contact the System Administrator\n")+
		i18n("for a copy of this policy.\n\n")+
		i18n("2) ADMINISTRATOR RIGHTS- The System Administrator reserves the right to suspend/delete\n")+
		i18n("your account at their discretion.  Your use of their System is a privelege, not a right!\n\n")+
		i18n("3) TERMS OF AGREEMENT- By clicking on 'Finish', you agree to said notification.  Failure to\n")+
		i18n("comply with these terms will void this Agreement.  Significant abuse of System may incur\n")+
		i18n("legal action against any parties involved in said abuse.\n")
		);

	QWidget *p3sp1;
	p3sp1 = new QWidget(p3vb1);

	QHBox *p3hb1 = new QHBox(p3vb1);
	p3hb1->setSpacing(KDialog::spacingHint());
	QLabel *p3lb1 = new QLabel(p3hb1);
	p3lb1->setText(i18n("Your Name:"));
	leFullname = new QLineEdit(p3hb1);

	QHBox *p3hb2 = new QHBox(p3vb1);
	p3hb2->setSpacing(KDialog::spacingHint());
	QLabel *p3lb2 = new QLabel(p3hb2);
	p3lb2->setText(i18n("Your Street Address:"));
	leAddrStreet = new QLineEdit(p3hb2);
	
	QHBox *p3hb3 = new QHBox(p3vb1);
	p3hb3->setSpacing(KDialog::spacingHint());
	QLabel *p3lb3 = new QLabel(p3hb3);
	p3lb3->setText(i18n("City:"));
	leAddrCity = new QLineEdit(p3hb3);
	QLabel *p3lb4 = new QLabel(p3hb3);
	p3lb4->setText(i18n("State/Province:"));
	leAddrState = new QLineEdit(p3hb3);
	QLabel *p3lb5 = new QLabel(p3hb3);
	p3lb5->setText(i18n("ZIP/Postal Code:"));
	leAddrZip = new QLineEdit(p3hb3);

	QHBox *p3hb4 = new QHBox(p3vb1);
	p3hb4->setSpacing(KDialog::spacingHint());
	QLabel *p3lb6 = new QLabel(p3hb4);
	p3lb6->setText(i18n("Telephone Number:"));
	leContPhone = new QLineEdit(p3hb4);
	
	QHBox *p3hb5 = new QHBox(p3vb1);
	p3hb5->setSpacing(KDialog::spacingHint());
	QLabel *p3lb7 = new QLabel(p3hb5);
	p3lb7->setText(i18n("E-mail Address:"));
	leContEmail = new QLineEdit(p3hb5);

	addPage(page3, i18n("Information About You"));
	setBackEnabled(page3, true);
	setFinishEnabled(page3, true);
	connect(finishButton(), SIGNAL(clicked()), this, SLOT(slotFinish()));
}

/**
 ** CxWndNewAcct::next(): Next was hit.
void		CxWndNewAcct::next() {

	switch(pageNumber) {

		case(0):
			page1->hide();
			page2->show();
			leUsername->setFocus();
			break;

		case(1):
			page2->hide();
			page3->show();
			leFullname->setFocus();
			break;

	}
	pageNumber++;
}
 **/

/**
 ** CxWndNewAcct::slotFinish(): Process this wizard's purpose.
 **/
void		CxWndNewAcct::slotFinish() {
USERINFO	user;
int		i = 0,hndl = 0;

	// BARE account information
	strcpy(user.username, leUsername->text().ascii());
	strcpy(user.password, lePassword->text().ascii());

	// Registration information
	strcpy(user.fullname, leFullname->text().ascii());
	strcpy(user.addr.street, leAddrStreet->text().ascii());
	strcpy(user.addr.city, leAddrCity->text().ascii());
	strcpy(user.addr.st, leAddrState->text().ascii());
	strcpy(user.addr.zip, leAddrZip->text().ascii());
	strcpy(user.contact.telephone, leContPhone->text().ascii());
	strcpy(user.contact.emailaddr, leContEmail->text().ascii());

	// Temporary kludge.
	if(!wndMain->isConnected()) {
		hndl = CxClConnection("bbs.shadowcom.net", 504, NULL, NULL);
                if(!CxClConnect( hndl )) {
                        KMessageBox::sorry(this,
                                i18n("The server 'bbs.shadowcom.net' could not be contacted.\nPlease try again later.\n\n(My apologies.  The 'new user' functionality is in the initial\ndesgin phase, so it's only programmed to connect to my server.\nThis _will_ get fixed soon!  :)"),
                                i18n("Unable to Connect!"),
                                false
                        );
                } else {
			wndMain->setConnected(1);
                }
	}

	// Pass to libCxClient
	if(!(i = CxUsCreate(hndl,user))) {

		wndMain->setHndl( hndl );
                wndMain->setUserName(leUsername->text());

                wndAction = new CxWndAction();
                wndAction->show();

                wndMain->setStatusMsg(i18n("Welcome, ")+leUsername->text()+i18n("!"));

                QTimer::singleShot(1, this, SLOT(hide()));
                QTimer::singleShot(600, wndMain, SLOT(initializeClient()));
                QTimer::singleShot(700, this, SLOT(close()));

	} else {
		CxWndLogin *login;

		switch(i) {
			case(1): 
				KMessageBox::sorry(this,
					i18n("You did not specify a username."),
					i18n("Failed creating account"),
					false
				);
				login = new CxWndLogin(NULL, QString::null);
				login->show();
				close();
				break;

			case(2):
				KMessageBox::sorry(this,
					i18n("The username you selected already exists."),
					i18n("Failed creating account"),
					false
				);
				login = new CxWndLogin(NULL, QString::null);
				login->show();
				close();
				break;
		}
	}
}

/**
 ** CxWndNewAcct::slotCancel(): Go back to the login screen.
 **/
void		CxWndNewAcct::slotCancel() {
	CxWndLogin *login = new CxWndLogin(NULL, QString::null);
	login->show();
	close();
}
