/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: wndtask.o
 ** Date: 2001-01-29
 ** Last Revision: 2001-01-29
 ** Description: Task composer/editor.
 ** CVS: $Id: wndtask.cpp,v 1.13 2001/07/25 02:22:15 brian Exp $
 **/
#include	<stdlib.h>
#include	<unistd.h>
#include        <iostream.h>
#include        <qmultilineedit.h>
#include        <qframe.h>
#include        <qradiobutton.h>
#include        <qcheckbox.h>
#include        <qstring.h>
#include        <qspinbox.h>
#include        <qlayout.h>
#include        <kglobal.h>
#include        <kiconloader.h>
#include        <ktoolbar.h>
#include        <kwin.h>
#include        <kapp.h>
#include        <kaccel.h>
#include        <klineedit.h>
#include        <kdialog.h>
#include        <klocale.h>
#include        <ktabctl.h>
#include        <kmessagebox.h>
#include        <dcopclient.h>
#include        <CxClient.h>
#include	"wndmain.h"
#include	"wndaddress.h"
#include	"wndtask.h"
#include	"rfc2426t.h"
#include	"autoconf.h"

#include	"icons/tasks_16x16.xpm"
#include	"icons/checkbox_off_16x16.xpm"
#include	"icons/checkbox_on_16x16.xpm"

#define		ID_SEND		0x1
#define		ID_CUT		0x1
#define		ID_COPY		0x1
#define		ID_PASTE	0x1
#define		ID_ATTACH	0x1
#define		ID_DELETE	0x1

extern CxWndMain *wndMain;

/**
 ** CxWndTask::CxWndTask(): Constructor
 **/
		CxWndTask::CxWndTask(int is_composer_window, Rfc2426t *task_obj):
		KMainWindow(0, 0) {
int		id;

	KAccel *keys = new KAccel(this);
	keys->connectItem(KStdAccel::Close, this, SLOT(close()));
	keys->connectItem(KStdAccel::Quit, this, SLOT(close()));
	keys->readSettings();

	KWin::setIcons(winId(), DesktopIcon("klipper"), QPixmap(tasks_16x16_xpm) );
	i_am_a_composer = is_composer_window;

	toolBar(0)->insertButton(QString("filesave"),ID_SEND, true, i18n("Save and Close"), -1, KGlobal::instance());
	toolBar(0)->insertLineSeparator();
	id = toolBar(0)->insertButton(QString("editcut"),ID_CUT, true, i18n("Cut"), -1, KGlobal::instance());
	toolBar(0)->setItemEnabled(id, false);
	id = toolBar(0)->insertButton(QString("editcopy"),ID_CUT, true, i18n("Copy"), -1, KGlobal::instance());
	toolBar(0)->setItemEnabled(id, false);
	id = toolBar(0)->insertButton(QString("editpaste"),ID_CUT, true, i18n("Paste"), -1, KGlobal::instance());
	toolBar(0)->setItemEnabled(id, false);
	id = toolBar(0)->insertButton(QString("attach"),ID_CUT, true, i18n("Attach File(s)"), -1, KGlobal::instance());
	toolBar(0)->setItemEnabled(id, false);
	toolBar(0)->insertLineSeparator();
	id = toolBar(0)->insertButton(QString("editdelete"),ID_CUT, true, i18n("Delete Task"), -1, KGlobal::instance());
	toolBar(0)->setItemEnabled(id, false);
	toolBar(0)->insertLineSeparator();
	id = toolBar(0)->insertButton(QString("up"),ID_CUT, true, i18n("Previous Item"), -1, KGlobal::instance());
	toolBar(0)->setItemEnabled(id, false);
	id = toolBar(0)->insertButton(QString("down"),ID_CUT, true, i18n("Next Item"), -1, KGlobal::instance());
	toolBar(0)->setItemEnabled(id, false);
	toolBar(0)->setFullSize(false);

	connect(toolBar(0), SIGNAL(clicked(int)), this, SLOT(processTbEvent(int))); 

	KTabCtl *tabs = new KTabCtl(this);

	/**
	 ** Page 1: Task Details
	 **/
	QWidget *page1 = new QWidget(tabs);
	tabs->addTab(page1, i18n("Task"));

	QGridLayout *grid = new QGridLayout(page1, 9, 7, KDialog::marginHint(), KDialog::spacingHint());

	/**
	 ** Row 1: Subject
	 **/
	QLabel *lblSubj = new QLabel(page1);
	lblSubj->setText(i18n("Subject:"));
	grid->addWidget(lblSubj, 0, 0, 0);

	d_Subject = new QLineEdit(page1);
	d_Subject->setText(QString::null);
	d_Subject->setFocus();
	connect(d_Subject, SIGNAL(textChanged(const QString &)), this, SLOT(slotUpdateCaption(const QString &)));
	grid->addMultiCellWidget( d_Subject, 0, 0, 1, 6, 0);

	/**
	 ** Row 2: Due Date
	 **/
	QLabel *lblDueDate = new QLabel(page1);
	lblDueDate->setText(i18n("Due Date:"));
	grid->addWidget(lblDueDate, 1, 0, 0);

	d_DueDate_off = new QRadioButton(page1);
	d_DueDate_off->setText(i18n("&None"));
	d_DueDate_off->setChecked( true );
	connect(d_DueDate_off, SIGNAL(clicked()), this, SLOT(slotDueDateOff()));
	grid->addWidget(d_DueDate_off, 1, 1, 0);

	d_DueDate_on = new QRadioButton(page1);
	d_DueDate_on->setText(i18n("&Due:"));
	d_DueDate_on->setChecked( false );
	connect(d_DueDate_on, SIGNAL(clicked()), this, SLOT(slotDueDateOn()));
	grid->addWidget(d_DueDate_on, 2, 1, 0);

	d_DueDate = new QLineEdit(page1);
	d_DueDate->setText(QString::null);
	d_DueDate->setEnabled( false );
	d_DueDate->setFixedWidth( 75 );
	grid->addWidget(d_DueDate, 2, 2, 0);

	QLabel *lblDueDateStart = new QLabel(page1);
	lblDueDateStart->setText(i18n("Start:"));
	lblDueDateStart->setAlignment( AlignRight );
	grid->addWidget(lblDueDateStart, 2, 3, AlignRight);

	d_DueDate_start = new QLineEdit(page1);
	d_DueDate_start->setText( QString::null );
	d_DueDate_start->setFixedWidth( 75 );
	grid->addWidget(d_DueDate_start, 2, 4, 0);

	/**
	 ** Separator
	 **/
	QFrame *sep1 = new QFrame( page1 );
	sep1->setFrameShape( QFrame::HLine );
	sep1->setFrameShadow( QFrame::Sunken );
	grid->addMultiCellWidget( sep1, 3, 3, 0, 6, 0 );

	/**
	 ** Status
	 **/
	QLabel *lblStatus = new QLabel( page1 );
	lblStatus->setText(i18n("Status"));
	grid->addWidget( lblStatus, 4, 0, 0 );

	QComboBox *d_Status = new QComboBox( page1 );
	d_Status->insertItem(i18n("Not Started"));
	d_Status->insertItem(i18n("In Progress"));
	d_Status->insertItem(i18n("Completed"));
	d_Status->insertItem(i18n("Waiting on someone else"));
	d_Status->insertItem(i18n("Deferred"));
	grid->addMultiCellWidget( d_Status, 4, 4, 1, 2, 0 );

	QLabel *lblPriority = new QLabel( page1 );
	lblPriority->setText(i18n("Priority:"));
	lblPriority->setAlignment( AlignRight );
	grid->addWidget( lblPriority, 4, 3, AlignRight );

	QComboBox *d_Priority = new QComboBox( page1 );
	d_Priority->insertItem(i18n("Low"));
	d_Priority->insertItem(i18n("Normal"));
	d_Priority->insertItem(i18n("High"));
	d_Priority->setCurrentItem( 1 );
	grid->addWidget( d_Priority, 4, 4, 0 );

	QLabel *lblComplete = new QLabel( page1 );
	lblComplete->setText(i18n("% Complete:"));
	grid->addWidget( lblComplete, 4, 5, 0 );

	QSpinBox *d_Complete = new QSpinBox( page1 );
	d_Complete->setValue( 0 );
	grid->addWidget( d_Complete, 4, 6, 0 );

	/**
	 ** Separator
	 **/
	QFrame *sep2 = new QFrame( page1 );
	sep2->setFrameShape( QFrame::HLine );
	sep2->setFrameShadow( QFrame::Sunken );
	grid->addMultiCellWidget( sep2, 5, 5, 0, 6, 0 );

	/**
	 ** Reminder Settings
	 **/
	QCheckBox *d_Reminder = new QCheckBox( page1 );
	d_Reminder->setText( i18n( "Re&minder:" ) );
	connect( d_Reminder, SIGNAL( clicked() ), this, SLOT( slotReminder() ));
	grid->addWidget(d_Reminder, 6, 0, 0);

	d_Reminder_Date = new QLineEdit( page1 );
	d_Reminder_Date->setText( QString::null );
	d_Reminder_Date->setFixedWidth( 75 );
	d_Reminder_Date->setEnabled( false );
	grid->addWidget(d_Reminder_Date, 6, 1, 0);

	d_Reminder_Time = new QLineEdit( page1 );
	d_Reminder_Time->setText( QString::null );
	d_Reminder_Time->setFixedWidth( 75 );
	d_Reminder_Time->setEnabled( false );
	grid->addWidget( d_Reminder_Time, 6, 2, 0 );

	QLabel *lblOwner = new QLabel( page1 );
	lblOwner->setText( i18n("Owner:") );
	grid->addWidget( lblOwner, 6, 3, AlignRight );

	QLineEdit *d_Owner = new QLineEdit( page1 );
	d_Owner->setText( wndMain->getUserName() );
	d_Owner->setEnabled( false );
	grid->addMultiCellWidget( d_Owner, 6, 6, 4, 6, 0 );

	/**
	 ** Remainder of Dialog: Details
	 **/
	d_Details = new QMultiLineEdit(page1);
	d_Details->setWordWrap(QMultiLineEdit::WidgetWidth);
	connect(d_Details, SIGNAL(textChanged()), this, SLOT(slotChanged()));
	grid->addMultiCellWidget( d_Details, 7, 7, 0, 6, 0);

	/**
	 ** Scattergories...
	 **/
	QPushButton *pb_Categories = new QPushButton( page1 );
	pb_Categories->setText( i18n("Cate&gories") );
	grid->addWidget( pb_Categories, 8, 0, 0 );

	QLineEdit *d_Category = new QLineEdit( page1 );
	d_Category->setText( QString::null );
	grid->addMultiCellWidget( d_Category, 8, 8, 1, 5, 0);

	d_Private = new QCheckBox( page1 );
	d_Private->setText( i18n("&Private") );
	grid->addWidget(d_Private, 8, 6, 0);

	/***********************************************************************
	 ** Page 2: Task Status
	 **/
	QWidget *page2 = new QWidget(tabs);
	tabs->addTab(page2, i18n("Status"));
	QGridLayout *grid2 = new QGridLayout(page2, 15, 3, KDialog::marginHint(), KDialog::spacingHint());
	grid2->setRowStretch(14, 10);

	/**
	 ** Date Completed
	 **/
	QLabel *lblCompleted = new QLabel( page2 );
	lblCompleted->setText( i18n("Date completed:") );
	grid2->addWidget( lblCompleted, 0, 0, 0 );

	QLineEdit *d_Completed = new QLineEdit(page2);
	d_Completed->setText(QString::null);
	d_Completed->setFixedWidth( 75 );
	grid2->addWidget( d_Completed, 0, 1, AlignLeft );

	/**
	 ** Total Work
	 **/
	QLabel *lblTotalWork = new QLabel( page2 );
	lblTotalWork->setText( i18n("Total work:") );
	grid2->addWidget( lblTotalWork, 1, 0, 0 );

	QLineEdit *d_TotalWork = new QLineEdit(page2);
	d_TotalWork->setText(QString::null);
	grid2->addMultiCellWidget( d_TotalWork, 1, 1, 1, 2, 0 );

	/**
	 ** Actual Work
	 **/
	QLabel *lblActualWork = new QLabel( page2 );
	lblActualWork->setText( i18n("Actual work:") );
	grid2->addWidget( lblActualWork, 2, 0, 0 );

	/**
	 ** Separator
	 **/
	QFrame *sep3 = new QFrame( page2 );
	sep3->setFrameShape( QFrame::HLine );
	sep3->setFrameShadow( QFrame::Sunken );
	grid2->addMultiCellWidget( sep3, 3, 3, 0, 2, 0 );

	/**
	 ** Mileage
	 **/
	QLabel *lblMileage = new QLabel( page2 );
	lblMileage->setText( i18n("Mileage:") );
	grid2->addWidget( lblMileage, 4, 0, 0 );

	/**
	 ** Billing Information
	 **/
	QLabel *lblBilling = new QLabel( page2 );
	lblBilling->setText( i18n("Billing Information:") );
	grid2->addWidget( lblBilling, 5, 0, 0 );

	/**
	 ** Billing Information
	 **/
	QLabel *lblContacts = new QLabel( page2 );
	lblContacts->setText( i18n("Contacts:") );
	grid2->addWidget( lblContacts, 6, 0, 0 );

	/**
	 ** Companies
	 **/
	QLabel *lblCompanies = new QLabel( page2 );
	lblCompanies->setText( i18n("Companies:") );
	grid2->addWidget( lblCompanies, 7, 0, 0 );

	/**
	 ** Separator
	 **/
	QFrame *sep4 = new QFrame( page2 );
	sep4->setFrameShape( QFrame::HLine );
	sep4->setFrameShadow( QFrame::Sunken );
	grid2->addMultiCellWidget( sep4, 8, 8, 0, 2, 0 );

	/**
	 ** Update List
	 **/
	QLabel *lblUpdateList = new QLabel( page2 );
	lblUpdateList->setText( i18n("Update list:") );
	grid2->addWidget( lblUpdateList, 9, 0, 0 );

	/**
	 ** Separator
	 **/
	QFrame *sep5 = new QFrame( page2 );
	sep5->setFrameShape( QFrame::HLine );
	sep5->setFrameShadow( QFrame::Sunken );
	grid2->addMultiCellWidget( sep5, 10, 10, 0, 2, 0 );

	QPushButton *pb_Unassign = new QPushButton( page2 );
	pb_Unassign->setText( i18n("Create Unassigned Copy") );
	pb_Unassign->setEnabled( false );
	grid2->addWidget( pb_Unassign, 11, 0, 0 );

	/**********************************************************
	 ** Load any data we can from our task object.
	 **/
	if(task_obj) {
		d_Subject->setText(task_obj->getSubject());
		d_Details->setText(task_obj->getDetails());
	}

	setCaption(d_Subject->text().isNull()?i18n("Untitled Task"):d_Subject->text());
	setCentralWidget(tabs);
	resize(620,400);

	ive_been_changed = false;
	ive_been_saved = false;
}

/**
 ** CxWndTask::slotChanged(): What if somebody edits us??
 **/
void		CxWndTask::slotChanged() {
	ive_been_changed = true;
}

/**
 ** CxWndTask::onSend(): Send message
 **/
void		CxWndTask::onSend() {
QString		s;
Rfc2426t	*task;
QCString	replyType;
QByteArray	replyData;

	if(!i_am_a_composer) return;

	task = new Rfc2426t();

	task->setSubject(d_Subject->text());
	task->setDetails(d_Details->text());

	/**
	 ** Encapsulate the note in a DCOP message, which will
	 ** be gingerly passed to the CxMessegner::deliverMessage()
	 ** call.
	 **/
	QByteArray data;
	QDataStream arg(data, IO_WriteOnly);
	QCStringList msginfo;
	msginfo.append( QCString("My Tasks") );     // msg.room
	msginfo.append( QCString("") );     // msg.author
	msginfo.append( QCString("bledbett@yellowbrix.com") );      // msg.rcpt
	msginfo.append( QCString("") );             // msg.cc
	msginfo.append( QCString("") );             // msg.subject
	msginfo.append( QCString(task->export_ascii()) );                  // msg.body
	arg << msginfo;

	if(kapp->dcopClient()->call("infusiond", "CxMessenger", "deliverMessage(QCStringList)", data,
			replyType, replyData )) {
		QDataStream reply(replyData, IO_ReadOnly);

		if( replyType == "int" ) {
			int results;
			reply >> results;

			if(!results) {
				ive_been_saved = true;
				delete task;
				close();
			} else {
				KMessageBox::sorry(this,
					i18n("I was unable to save your task.  You may\nnot have access to your \"My Tasks\" folder.\n(It is also possible that your Citadel/UX\nserver doesn't support this operation.)"),
					i18n("Unable to Save Task"),
					false
				);
			}
			
		} else {
			KMessageBox::sorry(this,
				i18n("I was unable to save your task.  You may\nnot have access to your \"My Tasks\" folder.\n(It is also possible that your Citadel/UX\nserver doesn't support this operation.)"),
				i18n("Unable to Save Task"),
				false
			);
		}

	} else {
		KMessageBox::sorry(this,
			i18n("I was unable to save your task.  You may\nnot have access to your \"My Tasks\" folder.\n(It is also possible that your Citadel/UX\nserver doesn't support this operation.)"),
			i18n("Unable to Save Task"),
			false
		);
	}
}

/**
 ** CxWndTask::queryClose(): Exit?
 **/
bool		CxWndTask::queryClose() {
int		i;

	if(ive_been_changed && !ive_been_saved) {
		i = KMessageBox::questionYesNo(this,
				(i_am_a_composer?i18n("Are you sure you wish to cancel the\nchanges you made to this task?"):i18n("Are you sure you wish to cancel\nthis task?")),
				i18n("Cancel changes?"),
				i18n("&Yes"),
				i18n("&No"),
				false
		);

		if(i != 3) {
			return false;
		}

	}

	return true;
}

/**
 ** CxWndTask::processTbEvent(): What happens when button x is hit?
 **/
void		CxWndTask::processTbEvent(int x) {

	switch(x) {

		case(ID_SEND):
			emit onSend();
			break;

		default:
			break;
	}
}

/**
 ** CxWndTask::slotUpdateCaption(): Update the titlebar.
 **/
void		CxWndTask::slotUpdateCaption(const QString &txt) {

	setCaption( __(txt.isEmpty()?i18n("Untitled Task"):txt) );
	ive_been_changed = true;
}

/**
 ** CxWndTask::openAddresser(): Open an addresser window.
 **/
void		CxWndTask::openAddresser() {

	CxWndAddress *adwin = new CxWndAddress(this, QString::null);
	connect(adwin, SIGNAL(setRcptAddr(const QString &)), this, 
			SLOT(setRcptAddr(const QString &)));
	adwin->show();
}

/**
 ** CxWndTask::setRcptAddr(): Set the recipient's address (called by CxWndAddress)
 **/
void		CxWndTask::setRcptAddr(const QString & s) {

	if(s);
}

/**
 ** CxWndTask::slotDueDateOn(): What happens when we click on DUE: ?
 **/
void		CxWndTask::slotDueDateOn() {

	if(*checkbox_on_16x16_xpm);
	d_DueDate_off->setChecked( false );
	d_DueDate_on->setChecked( true );
	d_DueDate->setEnabled( true );
}

/**
 ** CxWndTask::slotDueDateOff(): What happens when we click on DUE: ?
 **/
void		CxWndTask::slotDueDateOff() {

	if(*checkbox_off_16x16_xpm);
	d_DueDate_off->setChecked( true );
	d_DueDate_on->setChecked( false );
	d_DueDate->setEnabled( false );
}

/**
 ** CxWndTask::slotReminder(): The Reminder checkbox was clicked.
 **/
void		CxWndTask::slotReminder() {

	if(d_Reminder->isChecked()) {

		d_Reminder_Date->setEnabled( true );
		d_Reminder_Time->setEnabled( true );

	} else {

		d_Reminder_Date->setEnabled( false );
		d_Reminder_Time->setEnabled( false );
		
	}
}
